#include "../include/GV.h"

extern int DrawRotaGraphF( double xd, double yd, double ExRate, double Angle, int GrHandle, int TransFlag, int TurnFlag = FALSE  )  ;

static int menulevel;

#define maxx 30

//XV
void Menu_Update(){
	if(CheckStatePad(configpad.down)==1 || (CheckStatePad(configpad.down)>30 && CheckStatePad(configpad.down)%3==0))//L[Ă
		NowSelect = (NowSelect+1)%eMenu_Num;//IԂ
	if(CheckStatePad(configpad.up)==1 || (CheckStatePad(configpad.up)>30 && CheckStatePad(configpad.up)%3==0))//L[Ă
		NowSelect = (NowSelect+(eMenu_Num-1))%eMenu_Num;//IԂグ

	if(CheckStatePad(configpad.subA)==1){ //XL[Ă
		menu[eScene_Menu].flag=0;
		menu[eScene_Menu].cnt=30;
		NowSelect =eMenu_Num-1;
	}

	if(CheckStatePad(configpad.shot)==1){//ZL[ꂽ
		switch(NowSelect){//ݑI𒆂̏Ԃɂď𕪊
			//j[ڂ
			case eMenu_Game://Q[I𒆂Ȃ
				SceneMgr_ChangeScene(eScene_Game);//V[Q[ʂɕύX
				game_EXmode=0;
				break;
			case eMenu_GameEx:
				if(ch_savedata.stageEX_flag[0]>0 || ch_savedata.stageEX_flag[1]>0){
					SceneMgr_ChangeScene(eScene_Game);//V[Q[ʂɕύX
					game_EXmode=1;
				}
				break;
			case eMenu_Practice:
				SceneMgr_ChangeScene(eScene_Practice);
				break;
			case eMenu_Score:
				SceneMgr_ChangeScene(eScene_Score);
				break;
			case eMenu_Option://ݒI𒆂Ȃ
				SceneMgr_ChangeScene(eScene_Option);
				break;
			case eMenu_Omake:
				SceneMgr_ChangeScene(eScene_Omake);
				break;
			case eMenu_Quit:
				func_state=-1;
				break;
		}
		if(NowSelect==eMenu_Quit)
			return;
		if(NowSelect!=1 || (NowSelect==1 && (ch_savedata.stageEX_flag[0]>0 || ch_savedata.stageEX_flag[1]>0)) ){
			menu[eScene_Menu].flag=1;
			menu[eScene_Menu].cnt=51;
		}
	}
}

//`Bj[ڂ
void Menu_Draw(){
	int col[eGlevel_Num],dy[eGlevel_Num],x=290-sin(PI/2/maxx*menu[eScene_Game].x)*250;
	for(int i=0;i<eGlevel_Num;i++){
		dy[i] =180+i*60-(etc_count-1)*STARTSPD;
		col[i] =color[0];
		if(game_EXmode>0 || menu[eScene_Practice].state==7)
			col[NowSelect_Glevel] =color[7];
		else
			col[NowSelect_Glevel] =color[2];
	}

	if(NowSelect_Glevel==eGlevel_Blive)
		menulevel=eGlevel_Blive;
	else if(NowSelect_Glevel==eGlevel_Easy)
		menulevel=eGlevel_Easy;
	if(menu[eScene_Game].x>0 || menu[eScene_Menu].flag>0){
		DrawBox(0, dy[0]-1+NowSelect_Glevel*60, 640, dy[0]+17+NowSelect_Glevel*60, GetColor(0,0,60), TRUE);
		DrawString(x,	dy[0],	"EASY MODE",	col[0]);//
		DrawString(x,	dy[1],	"NORMAL MODE",	col[1]);
		DrawString(x,	dy[2],	"HARD MODE",	col[2]);
		DrawString(x,	dy[3],	"BLIVE MODE",	col[3]);
		if(menu[eScene_Practice].flag>0){
			for(int i=0;i<4;i++)
				DrawFormatString( x, dy[i]+30, color[0], "/score[%d]", ch_savepracticelist.score[NowSelect_Practice[0]][NowSelect_Practice[1]][i][NowSelect_Chara]);
		}
		if((game_EXmode==0 && (ch_savedata.stageEX_flag[0]>0 || ch_savedata.stageEX_flag[1]>0)) || (game_EXmode==1 && (ch_savedata.Exclear_flag[0]>0 || ch_savedata.Exclear_flag[1]>0))){
			DrawString(x,	dy[4],	"OWATA MODE",	col[4]);
			if(menu[eScene_Practice].flag>0)
				DrawFormatString( x, dy[4]+30, color[0], "/score[%d]", ch_savepracticelist.score[NowSelect_Practice[0]][NowSelect_Practice[1]][4][NowSelect_Chara]);
		}
		DrawString(x-30, dy[0]+NowSelect_Glevel*60, "", color[0]);
	}
}

//XV
void Game_Update(){
    if(CheckStatePad(configpad.down)==1 || (CheckStatePad(configpad.down)>30 && CheckStatePad(configpad.down)%3==0))//L[Ă
        NowSelect_Glevel = (NowSelect_Glevel+1)%eGlevel_Num;//IԂ
    if(CheckStatePad(configpad.up)==1 || (CheckStatePad(configpad.up)>30 && CheckStatePad(configpad.up)%3==0))//L[Ă
        NowSelect_Glevel = (NowSelect_Glevel+(eGlevel_Num-1))%eGlevel_Num;//IԂグ

    if(CheckStatePad(configpad.subA)==1){ //XL[Ă
		if(menu[eScene_Practice].flag >0)
			SceneMgr_ChangeScene(eScene_Practice);
		else if(menu[eScene_Omake].flag >0)
			SceneMgr_ChangeScene(eScene_Omake);
		else{
	        SceneMgr_ChangeScene(eScene_Menu);//V[j[ɕύX
			menu[eScene_Menu].flag=0;
			menu[eScene_Menu].cnt=30;
		}
		menu[eScene_Game].x =0;
		NowSelect_Glevel =0;
		NowSelect_Chara =0;
		game_EXmode =0;
    }

	if((game_EXmode==0 && ch_savedata.stageEX_flag[0]==0 && ch_savedata.stageEX_flag[1]==0) || 
		(game_EXmode==1 && ch_savedata.Exclear_flag[0]==0 && ch_savedata.Exclear_flag[1]==0)){
		if(NowSelect_Glevel==eGlevel_OWATA){
			if(menulevel==eGlevel_Blive)
				NowSelect_Glevel++;
			else if(menulevel==eGlevel_Easy)
				NowSelect_Glevel--;
			NowSelect_Glevel = NowSelect_Glevel%eGlevel_Num;
		}
	}
	if(CheckStatePad(configpad.shot)==1){//ZL[ꂽ
        switch(NowSelect_Glevel){//ݑI𒆂̏Ԃɂď𕪊
			//j[ڂ
			case eGlevel_Easy://
				game_rank=0;
				break;
			case eGlevel_Normal://ăj[ʂɖ߂
				game_rank=1;
				break;
			case eGlevel_Hard://
				game_rank=2;
				break;
			case eGlevel_Blive://ăj[ʂɖ߂
				game_rank=3;
				break;
			case eGlevel_OWATA://ăj[ʂɖ߂
				game_rank=4;
				break;
        }
		SceneMgr_ChangeScene(eScene_Chara);
		menu[eScene_Game].flag=1;
		menu[eScene_Game].cnt =0;
    }
}

//`
void Game_Draw(){
	Menu_Draw();

    int cnt=menu[eScene_Game].cnt,x1 =400,dy1[10],col1=color[0];
	for(int i=0;i<7;i++)
		dy1[i] =100+i*20-(etc_count-1)*STARTSPD;

	if(NowSelect_Glevel==eGlevel_Blive)
		menulevel=eGlevel_Blive;
	else if(NowSelect_Glevel==eGlevel_Easy)
		menulevel=eGlevel_Easy;

	if(menu[eScene_Game].flag==0){
		if(NowSelect_Glevel==0){
			DrawString(x1,	dy1[0],	"score@@@*0.5",	col1);
			DrawString(x1,	dy1[1],	"ch @@@@capacity++",	col1);
			DrawString(x1,	dy1[2],	"item@@@ rank+",	col1);
			DrawString(x1,	dy1[3],	"item@@@ pull+",	col1);

			DrawString(x1,	dy1[5],	"continue@ limit - no",	col1);
		}
		else if(NowSelect_Glevel==1){
			DrawString(x1,	dy1[0],	"score@@@*1.0",	col1);
			DrawString(x1,	dy1[1],	"ch @@@@capacity+",	col1);
			
			DrawString(x1,	dy1[3],	"item@@@ pull+",	col1);

			if(game_EXmode==0)
				DrawString(x1,	dy1[5],	"continue@ limit - 10",	col1);
			else
				DrawString(x1,	dy1[5],	"continue@ limit - no",	col1);
		}
		else if(NowSelect_Glevel==2){
			DrawString(x1,	dy1[0],	"score@@@*1.2",	col1);
			


			DrawString(x1,	dy1[4],	"bossskill@unlock",	col1);
			if(game_EXmode==0)
				DrawString(x1,	dy1[5],	"continue@ limit - 3",	col1);
			else
				DrawString(x1,	dy1[5],	"continue@ limit - no",	col1);
			DrawString(x1,	dy1[6],	"time@@@ limit - no",col1);
		}
		else if(NowSelect_Glevel==3 || NowSelect_Glevel==4){
			if(NowSelect_Glevel==3)
				DrawString(x1,	dy1[0],	"score@@@*1.5",	col1);
			else if(NowSelect_Glevel==4)
				DrawString(x1,	dy1[0],	"score@@@*2.0",	col1);
			DrawString(x1,	dy1[1],	"ch @@@@capacity-",	col1);
			DrawString(x1,	dy1[2],	"item@@@ rank-",	col1);
			DrawString(x1,	dy1[3],	"item@@@ pull-min",	col1);
			DrawString(x1,	dy1[4],	"bossskill@unlock+",	col1);
			if(game_EXmode==0)
				DrawString(x1,	dy1[5],	"continue@ limit - 0",	col1);
			else
				DrawString(x1,	dy1[5],	"continue@ limit - no",	col1);
			DrawString(x1,	dy1[6],	"time@@@ limit - no",col1);
		}
	}
}

void charastate(char selectchara){
	int mhp =250,mmp =600,mrest =9,mbomb =15;
	int whp =500,wmp =100,wrest =12,wbomb =2;
	int skillA =2,skillB =3;
	if(game_rank==1){
		mhp =200,mmp =550,mrest =7,mbomb =14;
		whp =450,wmp =85,wrest =10,wbomb =2;
	}
	else if(game_rank==2){
		mhp =150,mmp =500,mrest =5,mbomb =13;
		whp =400,wmp =70,wrest =8,wbomb =1;
	}
	else if(game_rank==3){
		mhp =100,mmp =450,mrest =3,mbomb =11;
		whp =350,wmp =60,wrest =6,wbomb =1;
	}
	else if(game_rank==4){
		mhp =1,mmp =0,mrest =1,mbomb =0;
		whp =1,wmp =0,wrest =1,wbomb =0;
	}

	if(selectchara==0){
		charamode=0;
		ch.rest_max	=ch.rest =mrest;
		ch.bomb_max	=ch.bomb =mbomb;
		chstateup.con_max	=ch.hp_max_max =ch.hp_max =ch.hp =mhp;
		chstateup.mag_max	=ch.mp_max_max =ch.mp_max =ch.mp =mmp;
		chstateup.def_max	=ch.def_max =ch.def =6;
		chstateup.dex_max	=ch.dex_max =ch.dex =10;
		chstateup.dexsub_max=ch.dexsub_max =ch.dexsub =8;
		chstateup.agi_max	=ch.spd_max =ch.spd =4;
		chstateup.eva_max	=ch.eva_max =ch.eva =30;
		chstateup.luc_max	=ch.luc_max =ch.luc =45;
		chstateup.skillA_rank =ch.subA_rank_max =ch.subA_rank =4;
		chstateup.skillB_rank =ch.subB_rank_max =ch.subB_rank =5;
		ch.range_max =ch.range =1.0;
		ch.grange_max =ch.grange =23.0;
		ch.crange_max =ch.crange =25.0;
		cshot_p=15; 
		cshot_sum=1;
		cshotsub_p =5;
		cshotsub_sum =2;
	}
	else{
		charamode=1;
		ch.rest_max	=ch.rest =wrest;
		ch.bomb_max	=ch.bomb =wbomb;
		chstateup.con_max	=ch.hp_max_max =ch.hp_max =ch.hp =whp;
		chstateup.mag_max	=ch.mp_max_max =ch.mp_max =ch.mp =wmp;
		chstateup.def_max	=ch.def_max =ch.def =8;
		chstateup.dex_max	=ch.dex_max =ch.dex =5;
		chstateup.dexsub_max=ch.dexsub_max =ch.dexsub =7;
		chstateup.agi_max	=ch.spd_max =ch.spd =7;
		chstateup.eva_max	=ch.eva_max =ch.eva =8;
		chstateup.luc_max	=ch.luc_max =ch.luc =12;
		chstateup.skillA_rank =ch.subA_rank_max =ch.subA_rank =0;
		chstateup.skillB_rank =ch.subB_rank_max =ch.subB_rank =0;
		ch.range_max =ch.range =2.5;
		ch.grange_max =ch.grange =23.0;
		ch.crange_max =ch.crange =25.0;
		cshot_sum=1; 
		cshot_p=10;
		cshotsub_p =1;
		cshotsub_sum =2;
	}
	ch.atk_max =ch.atk =0;
	ch.atksub_max =ch.atksub  =0;

	if(menu[eScene_Practice].flag==0){
		if(game_EXmode==0){
			ch.power =0;
			ch.tpower =0;
		}
		else{
			ch.power =100;
			ch.tpower =100;
		}
	}

	if(bossrash_flag>0){
		if(game_rank==0)
			ch.power =100;
		else if(game_rank==1)
			ch.power =60;
		else if(game_rank==2)
			ch.power =40;
		else if(game_rank==3)
			ch.power =20;
		else if(game_rank==4)
			ch.power =0;
	}
}

//XV
void Chara_Update(){
	if(menu[eScene_Chara].flag==0){
		if(CheckStatePad(configpad.down)==1 || (CheckStatePad(configpad.down)>30 && CheckStatePad(configpad.down)%3==0))//L[Ă
			NowSelect_Chara = (NowSelect_Chara+1)%eChara_Num;//IԂ
		if(CheckStatePad(configpad.up)==1 || (CheckStatePad(configpad.up)>30 && CheckStatePad(configpad.up)%3==0))//L[Ă
			NowSelect_Chara = (NowSelect_Chara+(eChara_Num-1))%eChara_Num;//IԂグ
		
		if(CheckStatePad(configpad.subA)==1){ //XL[Ă
			if(menu[eScene_Omake].flag ==1)
				SceneMgr_ChangeScene(eScene_Omake);
			else
				SceneMgr_ChangeScene(eScene_Game);//V[Q[xɕύX
			menu[eScene_Game].flag=0;
			menu[eScene_Chara].cnt =0;
		}
		charastate(NowSelect_Chara);
		if(CheckStatePad(configpad.shot)==1){//ZL[ꂽ
			memset(&ch,0,sizeof(ch_t));
			charastate(NowSelect_Chara);
			charamode =NowSelect_Chara;
			if(end_type==0){
				if(menu[eScene_Practice].flag ==0){
					if(game_EXmode==1){
						stage_num=6;
						ch.power =120;
					}
					else if(game_EXmode==0){
						stage_num=0;
						ch.power =0;
					}
				}
			}
			if(menu[eScene_Practice].flag >0){
				if(NowSelect_Practice[0]<ch_savedata.practice_flag[charamode]){
					menu[eScene_Game].cnt =maxx;
					menu[eScene_Chara].flag=1;
					menu[eScene_Chara].cnt =0;
					if(charamode==0)
						se_flag[5]=1;
					else if(charamode==1)
						se_flag[187]=1;
				}
				else
					se_flag[3]=1;
			}
			else if(menu[eScene_Omake].flag>0){
				if((NowSelect_Omake[0]<eOmake_exendstory && ch_savedata.stageEX_flag[charamode]>0) || 
					(NowSelect_Omake[0]>=eOmake_exendstory && ch_savedata.Exclear_flag[charamode]>0) ||
					NowSelect_Omake[0]==eOmake_midstory){
					menu[eScene_Game].cnt =maxx;
					menu[eScene_Chara].flag=1;
					menu[eScene_Chara].cnt =0;
					ch.power =120-game_rank*30;
					if(charamode==0)
						se_flag[5]=1;
					else if(charamode==1)
						se_flag[187]=1;
				}
				else
					se_flag[3]=1;
			}
			else{
				menu[eScene_Game].cnt =maxx;
				menu[eScene_Chara].flag=1;
				menu[eScene_Chara].cnt =0;
				if(charamode==0)
					se_flag[5]=1;
				else if(charamode==1)
					se_flag[187]=1;
			}
		}
	}
}

//`
void Chara_Draw(){
	if(menu[eScene_Omake].flag ==1)
		Omake_Draw();
	else
	    Game_Draw();
}