#include "../include/GV.h"

extern void graph_back_main();
extern void graph_back_sub();
extern void graph_back_sub1();
extern void draw_func_tm(int,int);
extern void graph_back06proend();

int DrawRotaGraphF( double xd, double yd, double ExRate, double Angle, int GrHandle, int TransFlag, int TurnFlag = FALSE  ) {
	return DrawRotaGraphF((float)xd,(float)yd,ExRate,Angle,GrHandle,TransFlag,TurnFlag);
}
int DrawModiGraphF( double x1, double y1, double x2, double y2, double x3, double y3, double x4, double y4, int GrHandle, int TransFlag ){
	return DrawModiGraphF( (float)x1, (float)y1, (float)x2, (float)y2, (float)x3, (float)y3, (float)x4, (float)y4, GrHandle, TransFlag ) ;
}

int DrawRotaGraphFdF( double xd, double yd, double ExRate, double Angle, int GrHandle, int TransFlag, int TurnFlag = FALSE  ) {
	return DrawRotaGraphF((float)xd+FX+dn.x,(float)yd+FY+dn.y,ExRate,Angle,GrHandle,TransFlag,TurnFlag);
}
int DrawModiGraphFdF( double x1, double y1, double x2, double y2, double x3, double y3, double x4, double y4, int GrHandle, int TransFlag ){
	return DrawModiGraphF( (float)x1+FX+dn.x, (float)y1+FY+dn.y, (float)x2+FX+dn.x, (float)y2+FY+dn.y, 
		(float)x3+FX+dn.x, (float)y3+FY+dn.y, (float)x4+FX+dn.x, (float)y4+FY+dn.y, GrHandle, TransFlag ) ;
}

int DrawCircleF(double xd, double yd, double rd, int col, int fill){
	return DrawCircle((float)xd+FX,(float)yd+FY, rd, col, fill);
}

int DrawCircleFdF(double xd, double yd, double rd, int col, int fill){
	return DrawCircle((float)xd+FX+dn.x,(float)yd+FY+dn.y, rd, col, fill);
}

int DrawBoxF(double xd1, double yd1, double xd2, double yd2, int col, int fill){
	return DrawBox((float)xd1+FX,(float)yd1+FY, xd2+FX,yd2+FY,col, fill);
}

int DrawBoxFdF(double xd1, double yd1, double xd2, double yd2, int col, int fill){
	return DrawBox((float)xd1+FX+dn.x,(float)yd1+FY+dn.y, xd2+FX+dn.x,yd2+FY+dn.y,col, fill);
}

int DrawStringFdF(double xd1, double yd1, char* string, int col){
	return DrawString(xd1+FX+dn.x,yd1+FY+dn.y, string, col);
}

int DrawStringToHandleF(double xd1, double yd1, char* string, int col, int font){
	return DrawStringToHandle((float)xd1+FX,(float)yd1+FY, string, col, font);
}


void graph_effect(int knd){
	for(int i=0;i<EFFECT_MAX;i++){
		if(effect[i].flag>0){
			SetDrawBlendMode( effect[i].eff, (int)effect[i].brt) ;

			if(effect[i].img>0){
				if(effect[i].knd==knd){
					if(bossrash_flag >0){
						if(stage_num==3 || (stage_num==5 && boss.graphnum==1)){
							SetDrawBlendMode( DX_BLENDMODE_INVSRC, 255) ;
							DrawRotaGraphF(effect[i].x+FX,effect[i].y+FY,effect[i].r,effect[i].ang,effect[i].img,TRUE);
							SetDrawBlendMode( DX_BLENDMODE_ADD, 255) ;
							DrawRotaGraphF(effect[i].x+FX,effect[i].y+FY,effect[i].r,effect[i].ang,effect[i].img,TRUE);
						}
						else
							DrawRotaGraphF(effect[i].x+FX,effect[i].y+FY,effect[i].r,effect[i].ang,effect[i].img,TRUE);
					}
					else
						DrawRotaGraphF(effect[i].x+FX,effect[i].y+FY,effect[i].r,effect[i].ang,effect[i].img,TRUE);
				}
			}
			else if(effect[i].knd==knd && effect[i].img==-1)//well
				DrawCircleFdF(effect[i].x,effect[i].y,effect[i].r,effect[i].col,TRUE);
			else if(effect[i].knd==knd && effect[i].img==-2)//boss
				DrawCircleFdF(effect[i].x,effect[i].y,effect[i].r,effect[i].col,TRUE);

			SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0) ;
		}
	}

	if(knd==1){
		if(charamode==0){
			if(ch.subA_flag>0){
				if(ch.subA_cnt>0 && ch.subA_cnt<150){
					if(ch.subA_cnt<40)//black
						SetDrawBlendMode( 1, ch.subA_cnt*5);//ADD2͖邳Aقǖ邢GႢقǓ	
					else
						SetDrawBlendMode( 1, 200);
					DrawBox(0,0,FMX+FX,FMY+FY,color[1], TRUE);
					SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0) ;
				}
				if(ch.subA_cnt>=90 && ch.subA_cnt<190){
					if(ch.subA_cnt>=150)//white
						SetDrawBlendMode( 2, 255-(ch.subA_cnt-150)*255/40.0);//ADD͖邳Aقǖ邢GႢقǓ	
					DrawBoxF(bom.dx0,bom.dy0,bom.dx1,bom.dy1,color[0], TRUE);
					SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0) ;
				}
			}
		}
		else{
			if(ch.subA_flag==1){
				double pos =30;
				int col;
				if(graph_change==1)
					col =color[6];
				else if(graph_change==2)
					col =color[7];
				else
					col =color[5];

				if(ch.subA_cnt<180){
					if(ch.subA_cnt%60==1)
						se_flag[24] =1;
					for(int i=0;i<1;i++)
						DrawCircleFdF(ch.x+cos(PI2*i+PI2/360*game_count*10)*pos,ch.y+sin(PI2*i+PI2/360*game_count*10)*pos,5,col,TRUE);
					ch.subA_state=0;
				}
				else if(ch.subA_cnt<180+180){
					if(ch.subA_cnt%30==1)
						se_flag[24] =1;
					for(int i=0;i<2;i++)
						DrawCircleFdF(ch.x+cos(PI2/2*i+PI2/360*game_count*15)*pos,ch.y+sin(PI2/2*i+PI2/360*game_count*15)*pos,5,col,TRUE);
					ch.subA_state=1;
				}
				else if(ch.subA_cnt<180+180+180){
					if(ch.subA_cnt%15==1)
						se_flag[24] =1;
					for(int i=0;i<3;i++)
						DrawCircleFdF(ch.x+cos(PI2/3*i+PI2/360*game_count*20)*pos,ch.y+sin(PI2/3*i+PI2/360*game_count*20)*pos,5,col,TRUE);
					ch.subA_state=2;
				}
				else if(ch.subA_cnt<180+180+180+60){
					if(ch.subA_cnt%5==1)
						se_flag[24] =1;
					for(int i=0;i<4;i++)
						DrawCircleFdF(ch.x+cos(PI2/4*i+PI2/360*game_count*30)*pos,ch.y+sin(PI2/4*i+PI2/360*game_count*30)*pos,5,col,TRUE);
					ch.subA_state=3;
				}
				else if(ch.subA_cnt<180+180+180+60+90){
					if(ch.subA_cnt==180+180+180+60)
						se_flag[101] =1;
					for(int i=0;i<4;i++)
						DrawCircleFdF(ch.x+cos(PI2/4*i+PI2/360*game_count*30)*pos,ch.y+sin(PI2/4*i+PI2/360*game_count*30)*pos,5,col,TRUE);
					ch.subA_state=4;
				}
				else if(ch.subA_cnt==180+180+180+60+90){
					StopSoundMem(sound_se[101]);
					ch.subA_state=5;
				}
				if(special_mode_stop>0){
					StopSoundMem(sound_se[24]);
					StopSoundMem(sound_se[101]);
				}
			}
		}
	}
}

void skill_bonus(){
	static int bonuscnt;

	if(etc_count==1)
		bonuscnt =0;
	if(boss.state==3 || bonuscnt>0){
		if(ch.beshot_flag==FALSE && boss.hp<=0){
			static int bonus;
			int param =(bonuscnt-99)*5;
			if(param<=0)
				param =0;
			if(bonuscnt==0){
				if(boss.endtime<60)
					bonus =boss.hp_max;
				else if(boss.endtime<60*100)
					bonus =boss.hp_max*(boss.endtime/60);
				else if(boss.endtime>=60*100)
					bonus =boss.hp_max*((60*100)/60);
			}
			SetDrawBlendMode( DX_BLENDMODE_ALPHA, 255-param);
			if(charamode==0)
				DrawFormatStringToHandle(FX, FY+FMY/2, color[0], font[6], "odqedbs score += %d", bonus);
			else if(charamode==1)
				DrawFormatStringToHandle(FX, FY+FMY/2, color[0], font[6], "odqedbsI score += %d", bonus);
			SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0) ;
			if(Continue.flag==0 && pose.flag==0)
				bonuscnt++;
		}
		if(bonuscnt>=150 || result.flag>0){
			bonuscnt =0;
			ch.beshot_flag=FALSE;
		}
	}
}

void boss_skill__boss_pos(){
	skill_bonus();
	if(boss_shot.flag==0)
		return;

	if(stage_num==6 && boss.knd==6){
		if(boss_effect.flag<=1)
			DrawStringToHandle(boss.x+32,FMY+16,"ɂ",color[0], font[2]);
		else{
			if(boss_shot.cnt<60)
				DrawStringToHandle(boss.x+32,FMY+16,"ɂ",color[0], font[2]);
			else{
				for(int i=0;i<3;i++)
					DrawStringToHandle(enemy[i].x+32,FMY+16,"ɂ",color[0], font[2]);
				DrawStringToHandle(boss.x+32,FMY+16,"ɂ",color[0], font[2]);
			}
		}
	}
	else if(stage_num==6 && boss.knd==1 && boss_effect.flag==2)
		DrawStringToHandle(FMX/2+32,FMY+16,"ɂiHj",color[0], font[2]);
	else{
		if(0<=boss.x && boss.x<=FMX && 0<=boss.y && boss.y<=FMY)
			DrawStringToHandle(boss.x+32,FMY+16,"ɂ",color[0], font[2]);
		else
			DrawStringToHandle(FMX/2,FMY+16,"킩܂񁄁",color[0], font[2]);
	}

	int et=boss.endtime;//bGh^C炵ĕ`
	int bt=boss.beforetime;
	#define ytime FMY+24
	#define xtime 10
	int numtype =1;
	if(stage_num==6)
		numtype =2;
	if(game_rank<2){
		if(boss.beforetime>=0 && boss.state>0 && boss.state%2==0){
			if(5940<bt){
				DrawRotaGraph(xtime+15,ytime,1.0f,0.0f,img_num[numtype][9],TRUE);
				DrawRotaGraph(xtime,ytime,1.0f,0.0f,img_num[numtype][9],TRUE);
			}
			else{
				bt/=60;
				DrawRotaGraph(xtime+15,ytime,1.0f,0.0f,img_num[numtype][bt%10],TRUE);bt/=10;
				DrawRotaGraph(xtime,ytime,   1.0f,0.0f,img_num[numtype][bt%10],TRUE);bt/=10;
			}
		}
		else if(boss.endtime>=0){
			if(5940<et){
				DrawRotaGraph(xtime+15,ytime,1.0f,0.0f,img_num[numtype][9],TRUE);
				DrawRotaGraph(xtime,ytime,   1.0f,0.0f,img_num[numtype][9],TRUE);
			}
			else{
				et/=60;
				DrawRotaGraph(xtime+15,ytime,1.0f,0.0f,img_num[numtype][et%10],TRUE);et/=10;
				DrawRotaGraph(xtime,ytime,	 1.0f,0.0f,img_num[numtype][et%10],TRUE);et/=10;
			}
		}
	}

	static int sy;
	if(boss_effect.cnt==1)
			sy =0;
	else if(boss_effect.cnt>=120 && pose.flag==0 && Continue.flag==0)
			sy++;
	if(boss_effect.flag>0){
		double x=5,y[5];
		for(int i=0;i<5;i++)
			y[i]=(224+50+i*15)-sy*8.5;
		if(menu[eScene_Practice].flag >2){
			if( (stage_num==1 && boss.knd==0) || (stage_num==6 && boss.knd==0))
				return;
			SetDrawBlendMode( DX_BLENDMODE_ALPHA, 150) ;
			DrawBoxF(x-1,y[0]-1,FMX-4-4,y[1],GetColor(120,120,120),TRUE);
			SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0) ;
			DrawStringToHandleF(x, y[0],	"practice",	color[0], font[2]);
		}
		else if(stage_num==0){
			SetDrawBlendMode( DX_BLENDMODE_ALPHA, 150) ;
			DrawBoxF(x-1,y[0]-1,FMX-4,y[2],GetColor(0,255,0),TRUE);
			SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0) ;
			switch(boss.knd){
				case 0: DrawStringToHandleF(x, y[0],	"cgbNKCXg",	color[0], font[2]);
						if(charamode==0)
							DrawStringToHandleF(x, y[1],	"uRCcccIv",	color[0], font[2]);
						else
							DrawStringToHandleF(x, y[1],	"ud|܂v",	color[0], font[2]);
						break;
				case 1: DrawStringToHandleF(x, y[0],	"K[[gbv",	color[0], font[2]);
						if(charamode==0)
							DrawStringToHandleF(x, y[1],	"u܂Ⴄ`Hv",	color[0], font[2]);
						else
							DrawStringToHandleF(x, y[1],	"u܂I@͂܂ꂽbIv",	color[0], font[2]);
						break;
				case 2: DrawStringToHandleF(x, y[0],	"}i`FWN",	color[0], font[2]);
						if(charamode==0)
							DrawStringToHandleF(x, y[1],	"uREQEPccnCbIv",	color[0], font[2]);
						else
							DrawStringToHandleF(x, y[1],	"ȕ`Hv",	color[0], font[2]);
						break;
			}
		}
		else if(stage_num==1){
			SetDrawBlendMode( DX_BLENDMODE_ALPHA, 150) ;
			if(boss.knd>0)
				DrawBoxF(x-1,y[0]-1,FMX-4,y[2],GetColor(0,255,255),TRUE);
			SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0) ;
			switch(boss.knd){
				case 0: break;
				case 1: DrawStringToHandleF(x, y[0],	"VJthBEH[^[",	color[0], font[2]);
						if(charamode==0)
							DrawStringToHandleF(x, y[1],	"u킠Iv",	color[0], font[2]);
						else
							DrawStringToHandleF(x, y[1],	"uP񂵂Ă[邭v",	color[0], font[2]);
						break;
				case 2: DrawStringToHandleF(x, y[0],	"ʁ߂߂ӂӂꁄ",	color[0], font[2]);
						if(charamode==0)
							DrawStringToHandleF(x, y[1],	"u킠Iv",	color[0], font[2]);
						else
							DrawStringToHandleF(x, y[1],	"uނ̂čKȂƁv",	color[0], font[2]);
						break;
				case 3: DrawStringToHandleF(x, y[0],	"tJJɉS",	color[0], font[2]);
						if(charamode==0)
							DrawStringToHandleF(x, y[1],	"u킠Iv",	color[0], font[2]);
						else
							DrawStringToHandleF(x, y[1],	"uEKɂ܂ă~ĂIv",	color[0], font[2]);
						break;
			}
		}
		else if(stage_num==2){
			SetDrawBlendMode( DX_BLENDMODE_ALPHA, 150) ;
			DrawBoxF(x-1,y[0]-1,FMX-4,y[2],GetColor(0,0,255),TRUE);
			SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0) ;
			switch(boss.knd){
				case 0: DrawStringToHandleF(x, y[0],	"LowA--XgCNt@O",	color[0], font[3]);
						if(charamode==0)
							DrawStringToHandleF(x, y[1],	"u܂ŉˁI@xłˁIv",	color[0], font[3]);
						else
							DrawStringToHandleF(x, y[1],	"uEVTIv",	color[0], font[3]);
						break;
				case 1: DrawStringToHandleF(x, y[0],	"SecA-I-J",	color[0], font[3]);
						if(charamode==0)
							DrawStringToHandleF(x, y[1],	"u΋ʎUX̐nIv",	color[0], font[3]);
						else
							DrawStringToHandleF(x, y[1],	"uɍʂƎUv",	color[0], font[3]);
						break;
				case 2: DrawStringToHandleF(x, y[0],	"ThiA-e-PPW}VK",	color[0], font[3]);
						if(charamode==0)
							DrawStringToHandleF(x, y[1],	"ua`mfI a`mfI a`mfIv",	color[0], font[3]);
						else
							DrawStringToHandleF(x, y[1],	"uMl͎̔Ȃv",	color[0], font[3]);
						break;
				case 3: DrawStringToHandleF(x, y[0],	"ForA--CGbW",	color[0], font[3]);
						if(charamode==0)
							DrawStringToHandleF(x, y[1],	"usAeہIv",	color[0], font[3]);
						else
							DrawStringToHandleF(x, y[1],	"uuAǑM̂悤ɁccIv",	color[0], font[3]);
						break;
			}
		}
		else if(stage_num==3){
			SetDrawBlendMode( DX_BLENDMODE_ALPHA, 150) ;
			if(boss.knd==0){
				if(boss_type==0)DrawBoxF(x-1,y[0]-1,FMX-4,y[2],GetColor(0,0,255),TRUE);
				else if(boss_type==1)DrawBoxF(x-1,y[0]-1,FMX-4,y[2],color[2],TRUE);
				else if(boss_type==2)DrawBoxF(x-1,y[0]-1,FMX-4,y[2],GetColor(0,255,0),TRUE);
				else if(boss_type==3)DrawBoxF(x-1,y[0]-1,FMX-4,y[2],GetColor(255,177,1),TRUE);
			}
			else{
				DrawBoxF(x-1,y[0]-1,FMX-4,y[2],GetColor(30,30,30),TRUE);
			}
			SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0) ;
			switch(boss.knd){
				case 0: if(boss_type==0)DrawStringToHandleF(x, y[0],	"VEH[^[T",	color[0], font[2]);
						else if(boss_type==1)DrawStringToHandleF(x, y[0],	"ΔVԁt@CT",	color[0], font[2]);
						else if(boss_type==2)DrawStringToHandleF(x, y[0],	"V΁EBhT",	color[0], font[2]);
						else if(boss_type==3)DrawStringToHandleF(x, y[0],	"yVXg[T",	color[0], font[2]);
						break;
				case 1: if(charamode==0){
							DrawStringToHandleF(x, y[0],	"oEB[N{\T",	color[0], font[3]);
							DrawStringToHandleF(x, y[1],	"uv",	color[0], font[3]);
						}
						else if(charamode==1){
							DrawStringToHandleF(x, y[0],	"PO\IT",	color[0], font[3]);
							DrawStringToHandleF(x, y[1],	"u킳v",	color[0], font[3]);
						}
						break;
				case 2: if(charamode==0){
							DrawStringToHandleF(x, y[0],	"d́OrgT",	color[0], font[3]);
							DrawStringToHandleF(x, y[1],	"uWv",	color[0], font[3]);
						}
						else if(charamode==1){
							DrawStringToHandleF(x, y[0],	"dtHgT",	color[0], font[3]);
							DrawStringToHandleF(x, y[1],	"uv",	color[0], font[3]);
						}
						break;
				case 3: if(charamode==0){
							DrawStringToHandleF(x, y[0],	"Vz\[[T",	color[0], font[3]);
							DrawStringToHandleF(x, y[1],	"uzv",	color[0], font[3]);
						}
						else if(charamode==1){
							DrawStringToHandleF(x, y[0],	"V[i[T",	color[0], font[3]);
							DrawStringToHandleF(x, y[1],	"uv",	color[0], font[3]);
						}
						break;
				case 4: if(charamode==0){
							DrawStringToHandleF(x, y[0],	"CP~gX",	color[0], font[3]);
							DrawStringToHandleF(x, y[1],	"uオv",	color[0], font[3]);
						}
						else if(charamode==1){
							DrawStringToHandleF(x, y[0],	"TW^A",	color[0], font[3]);
							DrawStringToHandleF(x, y[1],	"uāv",	color[0], font[3]);
						}
						break;
				case 5: if(charamode==0){
							DrawStringToHandleF(x, y[0],	"oT[XyX",	color[0], font[3]);
							DrawStringToHandleF(x, y[1],	"uߏグv",	color[0], font[3]);
						}
						else if(charamode==1){
							DrawStringToHandleF(x, y[0],	"VJhR",	color[0], font[3]);
							DrawStringToHandleF(x, y[1],	"uv",	color[0], font[3]);
						}
						break;
			}
		}
		else if(stage_num==4){
			SetDrawBlendMode( DX_BLENDMODE_ALPHA, 150) ;
			if(boss.knd==0)
				DrawBoxF(x-1,y[0]-1,FMX-4,y[2],GetColor(250,233,144),TRUE);
			else
				DrawBoxF(x-1,y[0]-1,FMX-4,y[2],GetColor(127,127,127),TRUE);
			SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0) ;
			switch(boss.knd){
				case 0: DrawStringToHandleF(x, y[0],	"ጶΓn",	color[0], font[2]);
						DrawStringToHandleF(x, y[1],	"uwȂƉ΂͌ŷׂ炸xČ܂ˁv",	color[0], font[2]);
						break;
				case 1: DrawStringToHandleF(x, y[0],	"^[igX󒆃|[Ԃ",	color[0], font[3]);
						if(charamode==0)
							DrawStringToHandleF(x, y[1],	"u͎g悤v",	color[0], font[3]);
						else
							DrawStringToHandleF(x, y[1],	"uΕԂĊ댯AȂāv",	color[0], font[3]);
						break;
				case 2: DrawStringToHandleF(x, y[0],	"E@[Cb`bUE[hECYEA[Y",	color[0], font[3]);
						if(charamode==0)
							DrawStringToHandleF(x, y[1],	"uE~܂BwDu bist so schoen.xv",	color[0], font[3]);
						else
							DrawStringToHandleF(x, y[1],	"u̎Ԃɒǂ邩BwSlowly go far.xv",	color[0], font[3]);
						break;
				case 3: DrawStringToHandleF(x, y[0],	"iCgt[ifoolsjC_[~^uCh",	color[0], font[3]);
						if(charamode==0)
							DrawStringToHandleF(x, y[1],	"uSāASĈׂ̈Ɂv",	color[0], font[3]);
						else
							DrawStringToHandleF(x, y[1],	"u邩Ǎ߂v",	color[0], font[3]);
						break;
			}
		}
		else if(stage_num==5){
			SetDrawBlendMode( DX_BLENDMODE_ALPHA, 150) ;
			if(boss.knd==0)
				DrawBoxF(x-1,y[0]-1,FMX-4,y[2],GetColor(0,0,255),TRUE);
			else if(boss.knd==1)
				DrawBoxF(x-1,y[0]-1,FMX-4,y[2],GetColor(30,30,30),TRUE);
			else if(boss.knd==2)
				DrawBoxF(x-1,y[0]-1,FMX-4,y[2],GetColor(255,127,0),TRUE);
			else if(boss.knd==3)
				DrawBoxF(x-1,y[0]-1,FMX-4,y[3],GetColor(127,127,127),TRUE);
			else
				DrawBoxF(x-1,y[0]-1,FMX-4,y[2],color[0],TRUE);
			SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0) ;
			int col =color[2];
			switch(boss.knd){
				case 0: DrawStringToHandleF(x, y[0],	"TopA-V-Blues Drive Monster",	color[0], font[3]);
						if(charamode==0)
							DrawStringToHandleF(x, y[1],	"uȂ鐢E𓥂ݍӂA΂Ȃ]݂̋PIv",	color[0], font[3]);
						else
							DrawStringToHandleF(x, y[1],	"ugɂȂ鎖ccv",	color[0], font[3]);
						break;
				case 1:	if(charamode==0){
							DrawStringToHandleF(x, y[0],	"oVCT[XgX",	color[0], font[3]);
							DrawStringToHandleF(x, y[1],	"uP蔚v",	color[0], font[3]);
						}
						else if(charamode==1){
							DrawStringToHandleF(x, y[0],	"VTW^R",	color[0], font[3]);
							DrawStringToHandleF(x, y[1],	"u܂v",	color[0], font[3]);
						}
							break;
				case 2: DrawStringToHandleF(x, y[0],	"ceiF",	color[0], font[2]);
						if(charamode==0)
							DrawStringToHandleF(x, y[1],	"uwȂ̂؂ƂȂxAȂāv",	color[0], font[2]);
						else
							DrawStringToHandleF(x, y[1],	"uA܂傤ccHv",	color[0], font[2]);
						break;
				case 3: if(game_rank<2){
							DrawStringToHandleF(x, y[0],	"}X^A{hCu}eAhCu",	color[0], font[3]);
							DrawStringToHandleF(x, y[1],	"wunlimited blave alterx",	color[0], font[3]);
							if(charamode==0)
								DrawStringToHandleF(x, y[2],	"uECnɕςāv",	color[0], font[3]);
							else
								DrawStringToHandleF(x, y[2],	"uwCheck out ma sord.xv",	color[0], font[3]);
						}
						else{
							if(boss_effect.flag<=2){
								DrawStringToHandleF(x, y[0],	"tCV[gbTCY`FW[",	color[0], font[3]);
								if(charamode==0)
									DrawStringToHandleF(x, y[1],	"u傫ȁ[v",	color[0], font[3]);
								else
									DrawStringToHandleF(x, y[1],	"urbNCg`v",	color[0], font[3]);
							}
							else if(boss_effect.flag<=4){
								DrawStringToHandleF(x, y[0],	"Et[WGC^[dea",	color[0], font[3]);
								if(charamode==0){
									DrawStringToHandleF(x, y[1],	"űɎ߂͐A̓ɂ炬ƒmB",	color[0], font[10]);
									DrawStringToHandleF(x, y[2],	"ivɏI\\G^[itH[XuU[hB͎ʁv",	color[0], font[10]);
								}
								else{
									DrawStringToHandleF(x, y[1],	"ui̍B͗₽炬̔B",	color[0], font[10]);
									DrawStringToHandleF(x, y[2],	"iv\\G^[itH[XuU[hB͎ʁv",	color[0], font[10]);
								}
							}
							else if(boss_effect.flag<=6){
								DrawStringToHandleF(x, y[0],	"E@[Cb``s",	color[0], font[3]);
								if(charamode==0)
									DrawStringToHandleF(x, y[1],	"ul琁BwAs Time Goes By.xv",	color[0], font[3]);
								else
									DrawStringToHandleF(x, y[1],	"u}ΉBwCarpe diem.xv",	color[0], font[3]);
							}
							else if(boss_effect.flag<=8){
								DrawStringToHandleF(x, y[0],	"JfbhXNGA",	color[0], font[3]);
								if(charamode==0)
									DrawStringToHandleF(x, y[1],	"uL][ɓĂ܂v",	color[0], font[3]);
								else
									DrawStringToHandleF(x, y[1],	"uA΂āv",	color[0], font[3]);
							}
							else if(boss_effect.flag<=10){
								DrawStringToHandleF(x, y[0],	"}X^A{hCu}eAhCu",	color[0], font[3]);
								DrawStringToHandleF(x, y[1],	"wunlimited blave alterx",	color[0], font[3]);
								if(charamode==0)
									DrawStringToHandleF(x, y[2],	"uECnɕςāv",	color[0], font[3]);
								else
									DrawStringToHandleF(x, y[2],	"uwCheck out ma sord.xv",	color[0], font[3]);
							}
						}
						break;
				case 4: DrawStringToHandleF(x, y[0],	"֒fԂʎ",	col, font[9]);
						DrawStringToHandleF(x, y[1],	"uA󂯎A̐^BfrÚAnɑv",	col, font[9]);
						break;
				case 5: DrawStringToHandleF(x, y[0],	"őMAe}Xp[N",	col, font[9]);
						DrawStringToHandleF(x, y[1],	"uCFq[EI[Bv",	col, font[9]);
						break;
				case 6: DrawStringToHandleF(x, y[0],	"ĐԗhS_X",	col, font[9]);
						DrawStringToHandleF(x, y[1],	"u͂̕З؁AĂv",	col, font[9]);
						break;
				case 7: DrawStringToHandleF(x, y[0],	"VX[p[nCe[V",	col, font[9]);
						DrawStringToHandleF(x, y[1],	"u鐯͌ʂ`v",	col, font[9]);
						break;
				case 8: DrawStringToHandleF(x, y[0],	"VXJCtH[AEg",	col, font[9]);
						DrawStringToHandleF(x, y[1],	"uVƂv",	col, font[9]);
						break;
				case 9: DrawStringToHandleF(x, y[0],	"AeJLVE",	col, font[9]);
						DrawStringToHandleF(x, y[1],	"uɂčׁB^Ėv",	col, font[9]);
						break;
			}
		}
		else if(stage_num==6){
			SetDrawBlendMode( DX_BLENDMODE_ALPHA, 150) ;
			if(boss.knd==1)
				DrawBoxF(x-1,y[0]-1,FMX-4,y[4],color[0],TRUE);
			else if(boss.knd>=2)
				DrawBoxF(x-1,y[0]-1,FMX-4,y[2],color[0],TRUE);
			SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0) ;
			int col =color[7];
			switch(boss.knd){
				case 0: break;
				case 1:	DrawStringToHandleF(x, y[0],	"N̖@",	col, font[7]);
						if(charamode==0)
							DrawStringToHandleF(x, y[1],	"u߂tXbgAAuJ_ubIv",	col, font[7]);
						else
							DrawStringToHandleF(x, y[1],	"ufB\\\\XbIv",	col, font[7]);
						if(boss_effect.flag<=2){
							DrawStringToHandleF(x, y[2],	"d\Ul<My failady>\",	col, font[7]);
							if(charamode==0)
								DrawStringToHandleF(x, y[3],	"uAi^邠̖͒NIHv",	col, font[7]);
							else
								DrawStringToHandleF(x, y[3],	"u̖Ai^͒NIHv",	col, font[7]);
						}
						else if(boss_effect.flag<=4){
							DrawStringToHandleF(x, y[2],	"\J<rauin>\",	col, font[7]);
							if(charamode==0)
								DrawStringToHandleF(x, y[3],	"uɓMIv",	col, font[7]);
							else
								DrawStringToHandleF(x, y[3],	"uVn󂷁Iv",	col, font[7]);
						}
						else if(boss_effect.flag<=6){
							DrawStringToHandleF(x, y[2],	"b\▭<puper sord>\",	col, font[7]);
							if(charamode==0)
								DrawStringToHandleF(x, y[3],	"urrrqtttttttttttrgIv",	col, font[7]);
							else
								DrawStringToHandleF(x, y[3],	"uPI@ƋPbbIv",	col, font[7]);
						}
						else if(boss_effect.flag<=8){
							DrawStringToHandleF(x, y[2],	"V\قƂ܂ق<romatica>\",	col, font[7]);
							if(charamode==0)
								DrawStringToHandleF(x, y[3],	"u˂Ďa􂯗ܐIv",	col, font[7]);
							else
								DrawStringToHandleF(x, y[3],	"uaxd axdCd`qsgIv",	col, font[7]);
						}
						else if(boss_effect.flag<=10){
							DrawStringToHandleF(x, y[2],	"nS\QZ<fooling love> \",	col, font[7]);
							if(charamode==0)
								DrawStringToHandleF(x, y[3],	"uwLe Petit PrincexIv",	col, font[7]);
							else
								DrawStringToHandleF(x, y[3],	"uĊ点Ał̒̐EIv",	col, font[7]);
						}
						else if(boss_effect.flag<=12){
							DrawStringToHandleF(x, y[2],	"zV\pY␳<he's law>\ ",	col, font[7]);
							if(charamode==0)
								DrawStringToHandleF(x, y[3],	"u́Ivv",	col, font[7]);
							else
								DrawStringToHandleF(x, y[3],	"uオECbIvv",	col, font[7]);
						}
						else if(boss_effect.flag<=14){
							DrawStringToHandleF(x, y[2],	"\]<absolute desire>\ ",	col, font[7]);
							if(charamode==0)
								DrawStringToHandleF(x, y[3],	"u̖҂͈؂̊]̂ĂIv",	col, font[7]);
							else
								DrawStringToHandleF(x, y[3],	"uo남[bIv",	col, font[7]);
						}
						break;
				case 2: DrawStringToHandleF(x, y[0],	"ehStA",	col, font[7]);
						if(charamode==0)
							DrawStringToHandleF(x, y[1],	"uECt؂ɓ˂ĂĖIv",	col, font[7]);
						else
							DrawStringToHandleF(x, y[1],	"u򉻂ĂIv",	col, font[7]);
						break;
				case 3: DrawStringToHandleF(x, y[0],	"ϓŗwhhEXg[",	col, font[7]);
						if(charamode==0)
							DrawStringToHandleF(x, y[1],	"uAÌłIv",	col, font[7]);
						else
							DrawStringToHandleF(x, y[1],	"uŐFɐ߂ĂIv",	col, font[7]);
						break;
				case 4: DrawStringToHandleF(x, y[0],	"FXJt|Pbg",	col, font[7]);
						if(charamode==0)
							DrawStringToHandleF(x, y[1],	"uO̐EȂǎ̎ɖʁIv",	col, font[7]);
						else
							DrawStringToHandleF(x, y[1],	"uAi^@΃Ai^ςIv",	col, font[7]);					
						break;
				case 5: DrawStringToHandleF(x, y[0],	"ٓEʗAEF[N",	col, font[7]);
						if(charamode==0)
							DrawStringToHandleF(x, y[1],	"uꗎċׁIv",	col, font[7]);
						else
							DrawStringToHandleF(x, y[1],	"uꏊĐIv",	col, font[7]);
						break;
				case 6: DrawStringToHandleF(x, y[0],	"SF`ChEvC",	col, font[7]);
						if(charamode==0)
							DrawStringToHandleF(x, y[1],	"uGɕ`悤ȗFBłIHv",	col, font[7]);
						else
							DrawStringToHandleF(x, y[1],	"u̗FBt[GhIv",	col, font[7]);
						break;
				case 7: DrawStringToHandleF(x, y[0],	"eahOXECu",	col, font[7]);
						if(charamode==0)
							DrawStringToHandleF(x, y[1],	"u̗͓Iv",	col, font[7]);
						else
							DrawStringToHandleF(x, y[1],	"ủ̂𒮂[Iv",	col, font[7]);
						break;
				case 8: DrawStringToHandleF(x, y[0],	"ŕPoOhtg",	col, font[7]);
						if(charamode==0)
							DrawStringToHandleF(x, y[1],	"uӂӂ[Iv",	col, font[7]);
						else
							DrawStringToHandleF(x, y[1],	"u킳킳Iv",	col, font[7]);
						break;
				case 9: DrawStringToHandleF(x, y[0],	"^C``hOE}Oi",	col, font[7]);
						if(charamode==0)
							DrawStringToHandleF(x, y[1],	"u菄ĉiIv",	col, font[7]);
						else
							DrawStringToHandleF(x, y[1],	"ujbLIv",	col, font[7]);
						break;
				case 10: DrawStringToHandleF(x, y[0],	"֗̂߂߂iCPiCA\rj",	col, font[7]);
						if(charamode==0)
							DrawStringToHandleF(x, y[1],	"uɗĂ̂Iv",	col, font[7]);
						else
							DrawStringToHandleF(x, y[1],	"u鎄͂ƖGIv",	col, font[7]);
						break;
				case 11: DrawStringToHandleF(x, y[0],	"iELV",	col, font[7]);
						DrawStringToHandleF(x, y[1],	"uƂɂȂŁccv",	col, font[7]);
						break;
			}
		}
	}
}

//item
void graph_item(){
	int i;
	for(i=0;i<ITEM_MAX;i++){
		if(item[i].flag==1){
			DrawRotaGraphFdF(item[i].x,item[i].y,item[i].r,PI2*(game_count%120)/120,img_item[item[i].knd][1],TRUE);
			DrawRotaGraphFdF(item[i].x,item[i].y,item[i].r*0.8,-PI2*(game_count%120)/120,img_item[item[i].knd][1],TRUE);
			DrawRotaGraphFdF(item[i].x,item[i].y,item[i].r,0,img_item[item[i].knd][0],TRUE);
		}
	}
}

//G`
void graph_enemy(){
	int i;
	for(i=0;i<ENEMY_MAX;i++){
		if(enemy[i].flag==1){
			if(enemy[i].graph_change==0){
				if(enemy[i].knd==0)
					DrawRotaGraphFdF(enemy[i].x,enemy[i].y,1.0f,0.0f,img_enemy[enemy[i].knd][enemy[i].col][enemy[i].img],TRUE);
				else if(enemy[i].knd==1)
					DrawRotaGraphFdF(enemy[i].x,enemy[i].y,1.0f,0.0f,img_enemy[enemy[i].knd][0][enemy[i].img],TRUE);
				else
					DrawRotaGraphFdF(enemy[i].x,enemy[i].y,1.0f,0.0f,img_enemy[enemy[i].knd][0][0],TRUE);
			}
			else if(enemy[i].graph_change==1)//EX-ꎞʒuApxA摜
				DrawRotaGraphFdF(enemy[i].temp_x,enemy[i].temp_y,1.0f,enemy[i].tang,img_enemy[enemy[i].knd][enemy[i].col][enemy[i].etc1],TRUE);
			else if(enemy[i].graph_change==2)//EX-ꎞʒuA傫
				DrawRotaGraphFdF(enemy[i].temp_x,enemy[i].temp_y,enemy[i].rate,0.0f,img_enemy[enemy[i].knd][enemy[i].col][enemy[i].img],TRUE);
			else if(enemy[i].graph_change==3){//stage6
				if(bossrash_flag>0)
					SetDrawBlendMode( DX_BLENDMODE_SUB, 255) ;
				if(menu[eScene_Practice].flag >0)
					DrawRotaGraphFdF(enemy[i].x,enemy[i].y,1.0f,0.0f,img_dotboss[17][0],TRUE);
				else
					DrawRotaGraphFdF(enemy[i].x,enemy[i].y,1.0f,0.0f,img_dotboss[6][0],TRUE);
			}
		}

	}

	SetDrawBlendMode( 0, 255) ;
}

//bosseffect
void graph_boss_effect(){
	double posx,posy;
	if(graph_change==2){
		posx =FMX/2;
		posy =FMY/4+sin(PI2/130*(etc_count%130))*10;
	}
	else{
		posx =boss.dx;
		posy =boss.dy;
	}

	SetDrawBlendMode( DX_BLENDMODE_ALPHA, 170) ;
	if(bossrash_flag >0){
		if(stage_num!=3 || (stage_num==6 && boss.graphnum==2))
			SetDrawBlendMode( DX_BLENDMODE_SUB, 255) ;
	}
	if(stage_num==0){
		if(1<boss.effectcnt && boss.effectcnt<30){
			DrawRotaGraphFdF(posx+20*sin(PI2/130*(boss.effectcnt%130)),
							posy+30*sin(PI2/100*(boss.effectcnt%100)),
							0.45*sin(PI2/120*(boss.effectcnt%120)),
							2*PI*(boss.effectcnt%30)/30,img_effect_boss[0][0],	TRUE);
			DrawRotaGraphFdF(posx+60*sin(PI2/200*((boss.effectcnt)%200)),
							posy+80*sin(PI2/177*((boss.effectcnt)%177)),
							0.35*sin(PI2/120*(boss.effectcnt%120)), 
							2*PI*(boss.effectcnt%35)/35,img_effect_boss[0][0],	TRUE);
		}
		if(boss.effectcnt>=30){
			DrawRotaGraphFdF(posx+20*sin(PI2/130*(boss.effectcnt%130)),
							posy+30*sin(PI2/100*(boss.effectcnt%100)),
							0.4+0.05*sin(PI2/120*(boss.effectcnt%120)),
							2*PI*(boss.effectcnt%30)/30,img_effect_boss[0][0],	TRUE);
			DrawRotaGraphFdF(posx+60*sin(PI2/200*((boss.effectcnt)%200)),
							posy+80*sin(PI2/177*((boss.effectcnt)%177)),
							0.3+0.05*sin(PI2/120*(boss.effectcnt%120)), 
							2*PI*(boss.effectcnt%35)/35,img_effect_boss[0][0],	TRUE);
		}
	}
	else if(stage_num==1){
		if(boss.knd>0){
			if(1<boss.effectcnt && boss.effectcnt<90){
				DrawRotaGraphFdF(posx,   posy,//@w
								(0.75*sin(PI2/360*(boss.effectcnt%360)))*3,
								PI2*(boss.effectcnt%580)/580,
								img_effect_boss[1][0], TRUE);
			}
			if(boss.effectcnt>=90){
				DrawRotaGraphFdF(posx,   posy,//@w
								(0.7+0.05*sin(PI2/360*(boss.effectcnt%360)))*3,
								PI2*(boss.effectcnt%580)/580,
								img_effect_boss[1][0], TRUE);
			}
		}
		if(1<boss.effectcnt && boss.effectcnt<30){
			DrawRotaGraphFdF(posx+50*cos(PI2/290*(boss.effectcnt%290)),
							posy+50*sin(PI2/290*(boss.effectcnt%290)),
							0.55*sin(PI2/120*(boss.effectcnt%120)),
							PI2*(boss.effectcnt%30)/30,img_effect_boss[1][0],	TRUE);
			DrawRotaGraphFdF(posx-50*cos(PI2/290*(boss.effectcnt%290)),
							posy-50*sin(PI2/290*(boss.effectcnt%290)),
							0.55*sin(PI2/120*(boss.effectcnt%120)),
							PI2*(boss.effectcnt%30)/30,img_effect_boss[1][0],	TRUE);
		}
		if(boss.effectcnt>=30){
			DrawRotaGraphFdF(posx+50*cos(PI2/290*(boss.effectcnt%290)),
							posy+50*sin(PI2/290*(boss.effectcnt%290)),
							0.5+0.05*sin(PI2/120*(boss.effectcnt%120)),
							PI2*(boss.effectcnt%30)/30,img_effect_boss[1][0],	TRUE);
			DrawRotaGraphFdF(posx-50*cos(PI2/290*(boss.effectcnt%290)),
							posy-50*sin(PI2/290*(boss.effectcnt%290)),
							0.5+0.05*sin(PI2/120*(boss.effectcnt%120)),
							PI2*(boss.effectcnt%30)/30,img_effect_boss[1][0],	TRUE);
		}
	}
	else if(stage_num==2 || (stage_num==5 && boss.knd==0)){
		int spincnt =90;
		if(boss_effect.flag>0)
			spincnt =30;
		for(int i=-1;i<2;i+=2){
			if(1<boss.effectcnt && boss.effectcnt<90){
				DrawRotaGraphFdF(posx,   posy,//@w
								0.95*sin(PI2/300*boss.effectcnt),
								i*PI2/spincnt*boss.effectcnt,
								img_effect_boss[2][0], TRUE);
			}
			if(boss.effectcnt>=90){
				DrawRotaGraphFdF(posx,   posy,//@w
								0.8+0.15*sin(PI2/300*boss.effectcnt),
								i*PI2/spincnt*boss.effectcnt,
								img_effect_boss[2][0], TRUE);
			}
		}
	}
	else if(stage_num==3 || (stage_num==5 && boss.knd==1)){
		int spincnt =420;
		if(boss.knd==0){
			if(bossrash_flag>0){
				SetDrawBlendMode( DX_BLENDMODE_INVSRC, 255) ;			
				if(1<boss.effectcnt && boss.effectcnt<90){
					DrawRotaGraphFdF(posx,   posy,//@w
									(0.8*sin(PI2/360*(boss.effectcnt%360))),
									PI2/spincnt*boss.effectcnt,
									img_effect_boss[3][boss_type], TRUE);
				}
				if(boss.effectcnt>=90){
					DrawRotaGraphFdF(posx,   posy,//@w
									(0.7+0.1*sin(PI2/360*boss.effectcnt)),
									PI2/spincnt*boss.effectcnt,
									img_effect_boss[3][boss_type], TRUE);
				}
				SetDrawBlendMode( DX_BLENDMODE_ADD, 255);
				if(1<boss.effectcnt && boss.effectcnt<90){
					DrawRotaGraphFdF(posx,   posy,//@w
									(0.8*sin(PI2/360*(boss.effectcnt%360))),
									PI2/spincnt*boss.effectcnt,
									img_effect_boss[3][boss_type], TRUE);
				}
				if(boss.effectcnt>=90){
					DrawRotaGraphFdF(posx,   posy,//@w
									(0.7+0.1*sin(PI2/360*boss.effectcnt)),
									PI2/spincnt*boss.effectcnt,
									img_effect_boss[3][boss_type], TRUE);
				}
			}
			else{
				if(1<boss.effectcnt && boss.effectcnt<90){
					DrawRotaGraphFdF(posx,   posy,//@w
									(0.8*sin(PI2/360*(boss.effectcnt%360))),
									PI2/spincnt*boss.effectcnt,
									img_effect_boss[3][boss_type], TRUE);
				}
				if(boss.effectcnt>=90){
					DrawRotaGraphFdF(posx,   posy,//@w
									(0.7+0.1*sin(PI2/360*boss.effectcnt)),
									PI2/spincnt*boss.effectcnt,
									img_effect_boss[3][boss_type], TRUE);
				}
			}
		}
		else{
			if(bossrash_flag>0){
				SetDrawBlendMode( DX_BLENDMODE_INVSRC, 255) ;
				if(1<boss.effectcnt && boss.effectcnt<90){
					DrawRotaGraphFdF(posx,   posy,//@w
									3.0*sin(PI2/360*boss.effectcnt),
									PI2/spincnt*boss.effectcnt,
									img_effect_boss[3][4], TRUE);
				}
				if(boss.effectcnt>=90){
					DrawRotaGraphFdF(posx,   posy,//@w
									2.9+0.1*sin(PI2/360*boss.effectcnt),
									PI2/spincnt*boss.effectcnt,
									img_effect_boss[3][4], TRUE);
				}
				SetDrawBlendMode( DX_BLENDMODE_ADD, 255);
				if(1<boss.effectcnt && boss.effectcnt<90){
					DrawRotaGraphFdF(posx,   posy,//@w
									3.0*sin(PI2/360*boss.effectcnt),
									PI2/spincnt*boss.effectcnt,
									img_effect_boss[3][4], TRUE);
				}
				if(boss.effectcnt>=90){
					DrawRotaGraphFdF(posx,   posy,//@w
									2.9+0.1*sin(PI2/360*boss.effectcnt),
									PI2/spincnt*boss.effectcnt,
									img_effect_boss[3][4], TRUE);
				}
			}
			else{
				if(1<boss.effectcnt && boss.effectcnt<90){
					DrawRotaGraphFdF(posx,   posy,//@w
									3.0*sin(PI2/360*boss.effectcnt),
									PI2/spincnt*boss.effectcnt,
									img_effect_boss[3][4], TRUE);
				}
				if(boss.effectcnt>=90){
					DrawRotaGraphFdF(posx,   posy,//@w
									2.9+0.1*sin(PI2/360*boss.effectcnt),
									PI2/spincnt*boss.effectcnt,
									img_effect_boss[3][4], TRUE);
				}
			}
		}
	}
	else if(stage_num==4 || (stage_num==5 && (boss.knd==2 || boss.knd==3)) ){
		if( (stage_num==4 && boss.knd==0) || (stage_num==5 && boss.knd==2)){
			int spincnt =360;
			for(int i=0;i<3;i++){
				if(boss.effectcnt<90){
					DrawRotaGraphFdF(posx,   posy,//@w
									((1.3-i*0.15)*sin(PI2/(360-i*20)*(boss.effectcnt%(360-i*20)))),
									PI2*(boss.effectcnt%spincnt)/spincnt,
									img_effect_boss[4][i], TRUE);
				}
				if(boss.effectcnt>=90){
					DrawRotaGraphFdF(posx,   posy,//@w
									((1.3-i*0.15)*sin(PI2/(360-i*20)*(boss.effectcnt%(360-i*20)))),
									PI2*(boss.effectcnt%spincnt)/spincnt,
									img_effect_boss[4][i], TRUE);
				}
			}
		}
		else{
			int moveang =90,spincnt =60;
			for(int i=0;i<10;i++){
				if(1<boss.effectcnt && boss.effectcnt<30){
					DrawRotaGraphFdF( posx+cos(-PI2/moveang*(boss.effectcnt+i*moveang/10))*90-sin(-PI2/moveang*(boss.effectcnt+i*moveang/10))*30,
										posy+sin(-PI2/moveang*(boss.effectcnt+i*moveang/10))*30+cos(-PI2/moveang*(boss.effectcnt+i*moveang/10))*90,
									0.55*sin(PI2/120*boss.effectcnt),
									PI2/30*-boss.effectcnt,img_effect_boss[4][3],	TRUE);
					DrawRotaGraphFdF( posx-cos(PI2/moveang*(boss.effectcnt+i*moveang/10))*90-sin(PI2/moveang*(boss.effectcnt+i*moveang/10))*30,
										posy-sin(PI2/moveang*(boss.effectcnt+i*moveang/10))*30+cos(PI2/moveang*(boss.effectcnt+i*moveang/10))*90,
									0.55*sin(PI2/120*boss.effectcnt),
									PI2/30*-boss.effectcnt,img_effect_boss[4][3],	TRUE);
					for(int s=-1;s<2;s+=2){
						DrawRotaGraphFdF(	posx+90*cos(s*PI2/120*(boss.effectcnt+i*120/10)),
											posy+30*sin(s*PI2/120*(boss.effectcnt+i*120/10)),
											0.55*sin(PI2/120*boss.effectcnt),
											PI2/30*boss.effectcnt,img_effect_boss[4][3],	TRUE);
					}
				}
				if(boss.effectcnt>=30){
					DrawRotaGraphFdF( posx+cos(-PI2/moveang*(boss.effectcnt+i*moveang/10))*90-sin(-PI2/moveang*(boss.effectcnt+i*moveang/10))*30,
										posy+sin(-PI2/moveang*(boss.effectcnt+i*moveang/10))*30+cos(-PI2/moveang*(boss.effectcnt+i*moveang/10))*90,
									0.5+0.05*sin(PI2/120*boss.effectcnt),
									PI2/30*-boss.effectcnt,img_effect_boss[4][3],	TRUE);
					DrawRotaGraphFdF( posx-cos(PI2/moveang*(boss.effectcnt+i*moveang/10))*90-sin(PI2/moveang*(boss.effectcnt+i*moveang/10))*30,
										posy-sin(PI2/moveang*(boss.effectcnt+i*moveang/10))*30+cos(PI2/moveang*(boss.effectcnt+i*moveang/10))*90,
									0.5+0.05*sin(PI2/120*boss.effectcnt),
									PI2/30*-boss.effectcnt,img_effect_boss[4][3],	TRUE);		
					for(int s=-1;s<2;s+=2){
						DrawRotaGraphFdF(	posx+90*cos(s*PI2/120*(boss.effectcnt+i*120/10)),
											posy+30*sin(s*PI2/120*(boss.effectcnt+i*120/10)),
											0.5+0.05*sin(PI2/120*boss.effectcnt),
											PI2/30*boss.effectcnt,img_effect_boss[4][3],	TRUE);
					}
				}
			}
		}
	}
	else if(stage_num==6 && boss.knd==0){
		int spin =20;
		for(int i=0;i<spin;i++){
			DrawRotaGraphFdF(	posx+100*sin(PI2/150*(boss.effectcnt+i*150/spin)), posy+150*sin(PI2/130*(boss.effectcnt+i*120/spin)),
								0.2+0.05*sin(PI2/360*boss.effectcnt),
								PI2/30*boss.effectcnt,
								img_effect_boss[stage_num][2],	TRUE);
			DrawRotaGraphFdF(	posx+100*sin(PI2/140*(boss.effectcnt+i*140/spin)), posy+120*sin(PI2/150*(boss.effectcnt+i*180/spin)),
								0.2+0.05*sin(PI2/360*boss.effectcnt),
								PI2/30*boss.effectcnt,
								img_effect_boss[stage_num][2],	TRUE);
		}
	}
	else if((stage_num==5 && boss.knd>3) || (stage_num==6 && boss.knd>0)){
		int spin =40,param =boss.effectcnt*2;
		if(param>=170)
			param =170;
		SetDrawBlendMode( DX_BLENDMODE_ALPHA, param) ;
		for(int i=0;i<spin;i++){
			DrawRotaGraphFdF(	posx+170*sin(PI2/150*(boss.effectcnt+i*150/spin)), posy+220*sin(PI2/130*(boss.effectcnt+i*120/spin)),
								0.2+0.05*sin(PI2/360*boss.effectcnt),
								PI2/30*boss.effectcnt,
								img_effect_boss[stage_num][2],	TRUE);
			DrawRotaGraphFdF(	posx+170*sin(PI2/140*(boss.effectcnt+i*140/spin)), posy+190*sin(PI2/150*(boss.effectcnt+i*180/spin)),
								0.2+0.05*sin(PI2/360*boss.effectcnt),
								PI2/30*boss.effectcnt,
								img_effect_boss[stage_num][2],	TRUE);
			DrawRotaGraphFdF(	posx+200*sin(PI2/130*(boss.effectcnt+i*130/spin)), posy+170*sin(PI2/160*(boss.effectcnt+i*160/spin)),
								0.2+0.05*sin(PI2/360*boss.effectcnt),
								PI2/30*boss.effectcnt,
								img_effect_boss[stage_num][2],	TRUE);
			if(stage_num==5){
				for(int s=0;s<4;s++){
					DrawRotaGraphFdF(	posx+(210+s*10)*sin(PI2/(130-s*5)*(boss.effectcnt+i*(130-s*5)/spin)), posy+(230-s*10)*sin(PI2/(150-s*5)*(boss.effectcnt+i*(150-s*5)/spin)),
									0.2+0.05*sin(PI2/360*boss.effectcnt),
									PI2/30*boss.effectcnt,
									img_effect_boss[stage_num][2],	TRUE);
				}
			}
		}
		SetDrawBlendMode( DX_BLENDMODE_ALPHA, 170) ;
		if(1<boss.effectcnt && boss.effectcnt<90){
			DrawRotaGraphFdF(posx,   posy,//@w
							(0.75*sin(PI2/360*(boss.effectcnt%360)))*3,
							PI2/580*(boss.effectcnt%580),
							img_effect_boss[stage_num][1], TRUE);
			DrawRotaGraphFdF(posx,   posy,//wO~
							(0.9*sin(PI2/360*(boss.effectcnt%360)))*2,
							PI2/340*(boss.effectcnt%340),img_effect_boss[stage_num][0],	TRUE);
		}
		if(boss.effectcnt>=90){
			DrawRotaGraphFdF(posx,   posy,//@w
							(0.7+0.05*sin(PI2/360*(boss.effectcnt%360)))*3,
							PI2/580*(boss.effectcnt%580),
							img_effect_boss[stage_num][1], TRUE);
			DrawRotaGraphFdF(posx,   posy,//wO~
							(0.8+0.1*sin(PI2/360*(boss.effectcnt%360)))*2,
							PI2/340*(boss.effectcnt%340),img_effect_boss[stage_num][0],	TRUE);
		}
	}

	SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0) ;
}

//boss
void graph_boss(){
	if(boss.flag==0)return;
	
	if(boss.effect>0)
		graph_boss_effect();
	if(menu[eScene_Practice].flag >0){
		if(graph_change==1)
			DrawRotaGraphFdF(boss.dx,boss.dy,1.0f,0.0f,img_bullet[1][3],TRUE);
		else if(graph_change==2){
			DrawRotaGraphFdF(FMX/2,FMY/4+sin(PI2/130*(etc_count%130))*10,1.0f,0.0f,img_dotboss[17][0],TRUE);
			DrawRotaGraphFdF(boss.x,boss.y,1.0f,1.0f,img_bullet[8][5],TRUE);
		}
		else
			DrawRotaGraphFdF(boss.dx,boss.dy,1.0f,0.0f,img_dotboss[17][0],TRUE);
	}
	else{
		if(bossrash_flag >0){
			if(stage_num!=3 || (stage_num==6 && boss.graphnum==2))
				SetDrawBlendMode( DX_BLENDMODE_SUB, 255) ;
		}
		if(graph_change==1)
			DrawRotaGraphFdF(boss.dx,boss.dy,1.0f,0.0f,img_bullet[1][3],TRUE);
		else if(graph_change==2){
			DrawRotaGraphFdF(FMX/2,FMY/4+sin(PI2/130*(etc_count%130))*10,1.0f,0.0f,img_dotboss[6][0],TRUE);
			DrawRotaGraphFdF(boss.x,boss.y,1.0f,1.0f,img_bullet[8][5],TRUE);
		}
		else{
			if(stage_num==0 || stage_num==2)
				DrawRotaGraphFdF(boss.dx,boss.dy,1.0f,0.0f,img_dotboss[stage_num][0],TRUE);
			else if(stage_num==1){
				if(boss.graphnum==0)
					DrawRotaGraphFdF(boss.dx,boss.dy,1.0f,0.0f,img_dotboss[15][0],TRUE);
				else{
					if(charamode==0)
						DrawRotaGraphFdF(boss.dx,boss.dy,1.0f,0.0f,img_dotboss[14][0],TRUE);
					else
						DrawRotaGraphFdF(boss.dx,boss.dy,1.0f,0.0f,img_dotboss[stage_num][0],TRUE);
				}
			}
			else if(stage_num==3){
				if(bossrash_flag >0){
					SetDrawBlendMode( DX_BLENDMODE_INVSRC, 255) ;
					if(boss.graphnum==0)
						DrawRotaGraphFdF(boss.dx,boss.dy,1.0f,0.0f,img_dotboss[10+boss_type][0],TRUE);
					else
						DrawRotaGraphFdF(boss.dx,boss.dy,1.0f,0.0f,img_dotboss[stage_num][0],TRUE);
					SetDrawBlendMode( DX_BLENDMODE_ADD, 255);
					if(boss.graphnum==0)
						DrawRotaGraphFdF(boss.dx,boss.dy,1.0f,0.0f,img_dotboss[10+boss_type][0],TRUE);
					else
						DrawRotaGraphFdF(boss.dx,boss.dy,1.0f,0.0f,img_dotboss[stage_num][0],TRUE);
				}
				else{
					if(boss.graphnum==0)
						DrawRotaGraphFdF(boss.dx,boss.dy,1.0f,0.0f,img_dotboss[10+boss_type][0],TRUE);
					else
						DrawRotaGraphFdF(boss.dx,boss.dy,1.0f,0.0f,img_dotboss[stage_num][0],TRUE);
				}
			}
			else if(stage_num==4){
				if(boss.graphnum==0)
					DrawRotaGraphFdF(boss.dx,boss.dy,1.0f,0.0f,img_dotboss[9][0],TRUE);
				else
					DrawRotaGraphFdF(boss.dx,boss.dy,1.0f,0.0f,img_dotboss[stage_num][0],TRUE);
			}
			else if(stage_num==5){
				if(boss.graphnum==0)
					DrawRotaGraphFdF(boss.dx,boss.dy,1.0f,0.0f,img_dotboss[2][0],TRUE);
				else if(boss.graphnum==1){
					if(bossrash_flag >0){
						SetDrawBlendMode( DX_BLENDMODE_INVSRC, 255) ;
						DrawRotaGraphFdF(boss.dx,boss.dy,1.0f,0.0f,img_dotboss[3][0],TRUE);
						SetDrawBlendMode( DX_BLENDMODE_ADD, 255);
						DrawRotaGraphFdF(boss.dx,boss.dy,1.0f,0.0f,img_dotboss[3][0],TRUE);
					}
					else
						DrawRotaGraphFdF(boss.dx,boss.dy,1.0f,0.0f,img_dotboss[3][0],TRUE);
				}
				else if(boss.graphnum==2)
					DrawRotaGraphFdF(boss.dx,boss.dy,1.0f,0.0f,img_dotboss[9][0],TRUE);
				
				else if(boss.graphnum==3)
					DrawRotaGraphFdF(boss.dx,boss.dy,1.0f,0.0f,img_dotboss[4][0],TRUE);
				else
					DrawRotaGraphFdF(boss.dx,boss.dy,1.0f,0.0f,img_dotboss[5][0],TRUE);
			}
			else if(stage_num==6){
				if(boss.graphnum==0)
					DrawRotaGraphFdF(boss.dx,boss.dy,1.0f,0.0f,img_dotboss[16][0],TRUE);
				else if(boss.dft_times>=2)
					DrawRotaGraphFdF(boss.dx,boss.dy,1.0f,0.0f,img_dotboss[7][0],TRUE);
				else
					DrawRotaGraphFdF(boss.dx,boss.dy,1.0f,0.0f,img_dotboss[6][0],TRUE);
			}
	//		DrawRotaGraphFdF(boss.dx,boss.dy,1.0f,0.0f,img_dotboss[boss.ang][boss.img],TRUE);
		}
	}
	/*
	if(boss.hp_max==0 && boss.hp==0){
		printfDx("graph_boss0\n");
		return;
	}
	*/
	
	SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0) ;
}

void graph_hp(){
	double subx = 0.98*boss.hp/boss.hp_max;
	if(boss.state>0 && boss.hp>0){
		DrawModiGraphFdF(
		3,			2,
		3+FMX*subx,	2,
		3+FMX*subx,	8,
		3,			8,
		img_etc[1],FALSE);
	}
}

//@`ATu`
void graph_ch(){
	double sx,sy,ny=(sin(2.0*PI*(count%50)/50)*3),ang=2.0*PI*(count%120)/120;

	if(CheckStatePad(configpad.slow)>0)//ᑬړȂ
		sx=15,sy=15+ny;//񂹂
	else
		sx=30,sy=30+ny;//ʂ̈ʒu

//	DrawRotaGraphFdF( ch.x-sx, ch.y+sy, 1.0f,  ang, img_chetc[2], TRUE );
//	DrawRotaGraphFdF( ch.x+sx, ch.y+sy, 1.0f, -ang, img_chetc[2], TRUE );
	if(special_mode_stop==0 && Continue.flag==0 && pose.flag==0){
		if(CheckStatePad(configpad.slow)>0)
			ch.slow=1;
		else
			ch.slow=0;
	}
	int rev=0;
	if(boss.flag>0 && ch.y<boss.y)
		rev =1;

	if(ch.mutekicnt%2==0){//GȂ_
		//@\
		if(graph_change==0)
			DrawRotaGraphFdF(ch.x,ch.y,1.0f,0.0f+PI*rev,img_dot_ch[charamode][ch.img],TRUE);
		else if(graph_change==1)
			DrawRotaGraphFdF(ch.x,ch.y,1.0f,0.0f+PI*rev,img_bullet[1][3],TRUE);
		else if(graph_change==2)
			DrawRotaGraphFdF(ch.x,ch.y,1.0f,0.0f+PI*rev,img_bullet[8][5],TRUE);
		if(ch.state[4]>0){
			SetDrawBlendMode( DX_BLENDMODE_ALPHA, 255-(ch.statecnt[4]*4%255));
			for(int i=0;i<5;i++)
				DrawCircleFdF( ch.x+ch.statex[4][i], ch.y+ch.statey[4][i] , 10 , color[7] , TRUE);
			SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0) ;
		}
		if(ch.state[6]>0){
			SetDrawBlendMode( DX_BLENDMODE_ALPHA, 255-(ch.statecnt[6]*4%255));
			for(int i=0;i<5;i++)
				DrawCircleFdF( ch.x+ch.statex[6][i], ch.y+ch.statey[6][i] , 10 , color[5] , TRUE);
			SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0) ;
		}
		if(ch.state[7]>0){
			for(int i=0;i<6;i++)
				DrawCircleFdF( ch.x+cos(PI2/60*(ch.statecnt[7]+i*10))*30, ch.y-20+sin(PI2/60*(ch.statecnt[7]+i*10))*10 , 6 , color[5] , TRUE);
		}
		if(ch.state[9]>0){
			if(ch.statecnt[9]%60<30)
				DrawRotaGraphFdF( ch.x, ch.y, 0.3, PI/4, img_back[3][6][6], TRUE );
		}
		if(ch.slow==1 && graph_change==0)//ᑬړȂ瓖蔻\
			DrawRotaGraphFdF( ch.x, ch.y, 1.0, 2.0*PI*(ch.cnt%120)/120, img_chetc[2], TRUE );
	}
	if(ch_savedata.gamemode_mp_bomb==0){
		if(ch.subB_flag>0){
			if(charamode==0){
				SetDrawBlendMode( DX_BLENDMODE_ALPHA, ch.mp*2);
				DrawCircleFdF( ch.x, ch.y , 30 , GetColor(0,0,255) , TRUE);
				SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0) ;
				DrawCircleFdF( ch.x, ch.y , ch.subB_cnt/2%30 , GetColor(0,0,255) , FALSE);
			}
			else{
				SetDrawBlendMode( DX_BLENDMODE_ALPHA, 255);
				DrawRotaGraphFdF(ch.x,ch.y,1.0f,ch.subB_ang+PI/2,img_cheff[1][ch.subB_cnt/4],TRUE);
				SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0) ;
			}
		}
	}
}

//@Vbg`
void graph_cshot(){
	for(int i=0;i<CSHOT_MAX;i++){
		if(cshot[i].flag>0){
			if(graph_change==1)
				DrawRotaGraphFdF(cshot[i].x,cshot[i].y,1,cshot[i].angle+PI/2,img_bullet[1][3],TRUE);
			else if(graph_change==2)
				DrawRotaGraphFdF(cshot[i].x,cshot[i].y,1,cshot[i].angle+PI/2,img_dot_ch[charamode][ch.img%4],TRUE);
			else
				DrawRotaGraphFdF(cshot[i].x,cshot[i].y,1,cshot[i].angle+PI/2,cshot[i].img,TRUE);
		}
	}
	for(int i=0;i<2;i++){//(49)Tu{
		int ang =(i ? -1 : 1);
		if(option_bb[i].flag>0){
			if(graph_change==1)
				DrawRotaGraphFdF(option_bb[i].x,option_bb[i].y,1.0,0,img_bullet[1][3],TRUE);
			else if(graph_change==2){
				int d=sin(PI/90*game_count)*30;
				DrawRotaGraphFdF(ch.x+cos(PI/180*game_count+PI*i)*d,ch.y+sin(PI/180*game_count+PI*i)*d,1.0f, 0, img_bullet[8][5+i],TRUE);
			}
			else{
				if(charamode==0)
					DrawRotaGraphFdF(option_bb[i].x,option_bb[i].y,1.0,PI2/180*game_count*ang,img_chetc[charamode],TRUE);
				else if(charamode==1){
					int movecnt =120;
					int s_op;
					if(ch.power>=120)s_op=18/2;
					else if(ch.power>=110)s_op=12/2;
					else if(ch.power>=100)s_op=14/2;
					else if(ch.power>=80)s_op=10/2;
					else if(ch.power>=60)s_op=6/2;
					else if(ch.power>=10)s_op=2/2;
					else if(ch.power>=0)s_op=0;
					for(int s=0;s<s_op;s++){
						DrawRotaGraphFdF( ch.x+60*cos(ang*PI2/movecnt*(game_count+s*movecnt/s_op)),
										  ch.y+30*sin(ang*PI2/movecnt*(game_count+s*movecnt/s_op)),
										  0.5+0.05*sin(PI2/120*game_count),
										  PI2/90*boss.cnt,img_chetc[charamode],	TRUE);
					}
				}
			}
		}
	}
}

void myDrawSquare(double x0, double y0,double x1, double y1,double x2, double y2,double x3, double y3){
	DrawTriangle((int)x0,(int)y0,(int)x1,(int)y1,(int)x2,(int)y2,color[2],TRUE);
	DrawTriangle((int)x0,(int)y0,(int)x3,(int)y3,(int)x2,(int)y2,color[2],TRUE);
}

void graph_lazer(){
	int i;
	SetDrawMode( DX_DRAWMODE_BILINEAR ) ;//`⊮`
	for(i=0;i<LAZER_MAX;i++){//G̒e[v
		if(lazer[i].flag>0){//ef[^IȂ
			SetDrawBlendMode( lazer[i].blend, lazer[i].param) ;
			if(lazer[i].st_nograph==0){
				DrawRotaGraphFdF(//ˈʒũGtFNg`
					lazer[i].startpt.x,lazer[i].startpt.y,1.0,0,
					img_lazer_moto[lazer[i].knd][lazer[i].col],TRUE
				);
			}
			DrawModiGraphFdF(//[U[`
				lazer[i].disppt[0].x, lazer[i].disppt[0].y, 
				lazer[i].disppt[1].x, lazer[i].disppt[1].y, 
				lazer[i].disppt[2].x, lazer[i].disppt[2].y, 
				lazer[i].disppt[3].x, lazer[i].disppt[3].y, 
				img_lazer[lazer[i].knd][lazer[i].col],TRUE
			);                    
			SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0) ;
/*			myDrawSquare(//蔻͈͂\
				lazer[i].outpt[0].x,lazer[i].outpt[0].y,
				lazer[i].outpt[1].x,lazer[i].outpt[1].y,
				lazer[i].outpt[2].x,lazer[i].outpt[2].y,
				lazer[i].outpt[3].x,lazer[i].outpt[3].y
			);*/
		}
	}
}

//eۂ̕`
void graph_bullet(){
	int i,j;
	double disp_angle;
	SetDrawMode( DX_DRAWMODE_BILINEAR ) ;//`⊮`
	for(i=0;i<SHOT_MAX;i++){//G̒e[v
		if(shot[i].flag>0 ){//ef[^IȂ
			for(j=0;j<SHOT_BULLET_MAX;j++){//̒ee̍ő吔[v
				if(shot[i].bullet[j].flag!=0){//ef[^IȂ
					if(shot[i].bullet[j].eff==1)
						SetDrawBlendMode( DX_BLENDMODE_ADD, 255) ;
					if(bullet_info[shot[i].bullet[j].knd].kaiten==1)
						disp_angle=PI2*(shot[i].bullet[j].cnt%120)/120;
					else
						disp_angle=shot[i].bullet[j].angle+PI/2;

					DrawRotaGraphFdF(
						shot[i].bullet[j].x, shot[i].bullet[j].y,
						1.0, disp_angle,
						img_bullet[shot[i].bullet[j].knd][shot[i].bullet[j].col],TRUE);

					SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0) ;
				}
			}
		}
	}
	//{X
	if(boss_shot.flag>0){//ef[^IȂ
		for(j=0;j<BOSS_BULLET_MAX;j++){//̒ee̍ő吔[v
			if(boss_shot.bullet[j].flag!=0 && boss_shot.bullet[j].knd>=0){//ef[^IȂ
				if(boss_shot.bullet[j].kaiten>0)
					disp_angle=PI2/360*boss_shot.bullet[j].kaiten*boss_shot.bullet[j].cnt;
				else
					disp_angle=boss_shot.bullet[j].angle+PI/2;

				if(boss_shot.bullet[j].eff==0){
					//O͒ʏAP͓AQ͌ param͌El255
					SetDrawBlendMode( boss_shot.bullet[j].mode, boss_shot.bullet[j].param);
					DrawRotaGraphFdF(
						boss_shot.bullet[j].x, boss_shot.bullet[j].y,
						boss_shot.bullet[j].rate, disp_angle,
						img_bullet[boss_shot.bullet[j].knd][boss_shot.bullet[j].col],TRUE);
				}
				else if(boss_shot.bullet[j].eff==1){//摜̕ύX
					int image =img_enemy[boss_shot.bullet[j].etc2][boss_shot.bullet[j].col][boss_shot.bullet[j].etc3];
					if(boss_shot.bullet[j].temp_ang2==0)
						DrawRotaGraphFdF(
							boss_shot.bullet[j].x, boss_shot.bullet[j].y,
							boss_shot.bullet[j].rate, disp_angle,
							image,TRUE);
	//						DrawRotaGraphFdF(enemy[i].temp_x,enemy[i].temp_y,1.0f,enemy[i].tang,,TRUE);
					else
						DrawRotaGraphFdF(
							boss_shot.bullet[j].x, boss_shot.bullet[j].y,
							boss_shot.bullet[j].rate, boss_shot.bullet[j].temp_ang2,
							image,TRUE);
	//						DrawRotaGraphFdF(enemy[i].temp_x,enemy[i].temp_y,1.0f,enemy[i].tang,,TRUE);
				}
				SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0) ;
			}
		}
	}
	SetDrawMode(DX_DRAWMODE_NEAREST);//``߂
}

//^Cg̕\
void graph_stage_title(){
	if(stage_count>720 || bossrash_flag>0)
		return;

	int param =0;
	double dx=FMX;

	if(stage_count>=120){
		if(stage_count<360){
			param =(stage_count-120)*4;
			if(param>255)
				param =255;
		}
		else
			param =255-(stage_count-360)*4;

		dx=FMX-(stage_count-120)*1.5;
	}

	SetDrawBlendMode( DX_BLENDMODE_ALPHA, param );
	if(stage_num==0){
		DrawStringToHandleF(FMX/2, FMY/2,	"rs`fd P",	color[0], font[6]);
		DrawStringToHandleF(dx, FMY/2+30,	"[[ -i'm waiting here-",	color[0], font[4]);
	}
	else if(stage_num==1){
		DrawStringToHandleF(FMX/2, FMY/2,	"rs`fd Q",	color[0], font[6]);
		DrawStringToHandleF(dx, FMY/2+30,	"V̔ޕ -over the raybow-",	color[0], font[4]);
	}
	else if(stage_num==2){
		DrawStringToHandleF(FMX/2, FMY/2,	"rs`fd R",	color[0], font[6]);
		DrawStringToHandleF(dx, FMY/2+30,	"X̘T -in the lost(?) woods-",	color[0], font[4]);
	}
	else if(stage_num==3){
		DrawStringToHandleF(FMX/2, FMY/2,	"rs`fd S",	color[0], font[6]);
		DrawStringToHandleF(dx, FMY/2+30,	"QO̐ -need you-",	color[0], font[4]);
	}
	else if(stage_num==4){
		DrawStringToHandleF(FMX/2, FMY/2,	"rs`fd T",	color[0], font[6]);
		DrawStringToHandleF(dx, FMY/2+30,	"⌎̋Rm -day dream believer-",	color[0], font[4]);
	}
	else if(stage_num==5){
		DrawStringToHandleF(FMX/2, FMY/2,	"rs`fd last",	color[0], font[6]);
		DrawStringToHandleF(FMX/2+70, FMY/2+30,	" -elf king-",	color[0], font[4]);
	}
	else if(stage_num==6){
		DrawStringToHandleF(FMX/2, FMY/2,	"rs`fd lost",	color[0], font[6]);
		DrawStringToHandleF(dx, FMY/2+30,	"̂Pl -dare or dire-",	color[0], font[4]);
	}
	SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0 );
}

//afl^Cg\
void graph_board_bgm(){
	char musicname[][64] ={	"aflwmints -club mix-x",
							"aflwꐯC̑nx",
							"aflwParade der Zinnsoldatenx",
							"aflwThe Entertainerx",
							"aflwrainy timex",
							"aflwLet's go with mex",
							"aflwOrpheus in the Underworldx",
							"aflwh.b.sx",										
							"aflwx",										
							"aflwSong for Explorerx",							
							"aflwRun like the windx",							
							"aflwVx",										
							"aflw̋󒆒뉀x",								
							"aflwr̊Cx",										
							"aflwiȂP̂ƂɁx",							
							"aflwCOSMIC ORCHESTRAx",								
							"aflwRmcƏNx",									
							"aflw𐶂钬x",									
							"aflwrootx",											
							"aflwpiano~fortex",								
							"aflwāx",											
							"aflwErlkonigx",										
							"aflwOne's believesx",								
							"aflw_[fGx",								
							"aflwNight on Bald Mountain(Rimsky-Korsakov ver.)x",	
							"aflwA Midsummer Night's Dream<scherzo>x",			
							"aflw̃mɂȂȂx",							
							"aflwChocolateMagicx",								
							"aflwEMBLEM BATTLEx",								
							"aflwfreezing pointx",								
							"aflwLike a Violet quartzx",							
							"aflwFinalize (void's romantix mix)x",				
							"aflwThe Final Crossx",								
							"aflwHON̕x",							
							"aflwzx",											
							"aflw̗lx",										
							"aflw{XOVx",								
							"aflwFire stormx",						
							"aflwThe Decesive Battlex",				
							"aflwDance Under Your Heartx",			
							"aflwʂĖrx",						
							"aflwEllens dritter Gesang 0p.52-6x",	
							"aflwKinderszenen Op.15-7<Traumerei>x",	
							"aflwStars and Stripes Foreverx",		
							"aflwKanonx",							
							"aflwArie auf Gx",						
							"aflw̎Uҁx",					
							"aflwFrom the New Worldx",				
							"aflwLe carnaval des animaux<Aquarium>x",
							"aflwςȊXx",				
							"aflwLets Take a Restx",
							"邳",
							"ÂɔԂ̂DȂ",
							""};
	static int num;
	static int x;
	if(NowSelect_Music!=eMusic_ok && CheckStatePad(configpad.shot)==1 && pose.flag==3)
		num =NowSelect_Music;
	if(etc_count==1 || (talk.state==3 && boss.music>0)){
		if(etc_count==1 || (talk.state==3 && boss.music>0 && menu[eScene_Practice].flag==0) ){
			x =640+240;
			num =stage_num*4+charamode+boss.music*2;
		}
		if(boss.music==2)
			num =28;
		if(menu[eScene_Practice].flag>0)
			num =35;
		if(bossrash_flag>0)
			num =36;
	}
	if(special_mode_stop==0 && Continue.flag==0 && pose.flag==0){
		x -=2;
		if(x<=0)
			x =0;
	}

	DrawStringToHandle(x, 0,	musicname[num],	color[0], font[11]);
};

//Xe[^X\(41)
void graph_board_states(){
	if(ch.score>=999999999)ch.score =999999999;
	if(ch.graze>=9999)ch.graze =9999;
	if(ch.point>=9999)ch.point =9999;
	if(ch.hit>=9999)ch.hit =9999;

	int i;
	int score=ch.score;
	int power=ch.power;
	int bomb=ch.bomb;
	int graze=ch.graze;
	int point=ch.point;
	int hit =ch.hit;
    if(ch.score > ch_savedata.hscore && menu[eScene_Practice].flag==0 && bossrash_flag==0)
		ch_savedata.hscore=ch.score;
	int hscore=ch_savedata.hscore;
	int skillA =ch.subA_rank;
	int skillB =ch.subB_rank;
	int atk =(cshot_p*cshot_sum)*(100+ch.atk)/100/2;
	int atksub =(cshotsub_p*cshotsub_sum)*(100+ch.atksub)/100/2;
	int def =ch.def;
	int dex =ch.dex;
	int dexsub =ch.dexsub;
	int spd =ch.spd;
	int eva =ch.eva;
	int luc =ch.luc;
	
	DrawStringToHandle(419, 50-FY/2,	"HSCORE",	color[0], font[5]);
	DrawStringToHandle(433, 70-FY/2,	"SCORE",	color[0], font[5]);
	for(i=0;i<9;i++){//XRA\
		DrawRotaGraph(625-15*i,50,1.0f,0.0f,img_num[0][hscore%10],TRUE);hscore/=10;
		DrawRotaGraph(625-15*i,70,1.0f,0.0f,img_num[0][score%10],TRUE);score/=10;
	}
	
	int statey=100;
	if(ch_savedata.gamemode_hp_rest==1){
		char grest[64];//c@\
		sprintf_s(grest, "REST %d / %d", ch.rest, ch.rest_max);
		DrawString(419, statey, grest, color[0]);
		for(i=0;i<ch.rest;i++)
			DrawGraphF(419+12*i,statey+15,img_etc[9],TRUE);
	}
	else if(ch_savedata.gamemode_hp_rest==0){//HP,MP\
		double hpsub = 0.9*ch.hp/ch.hp_max;
		char ghp[64];
		sprintf_s(ghp, "HP %d / %d", ch.hp, ch.hp_max);
		DrawString(419, statey, ghp, color[0]);
		if(ch.hp>0){
				DrawModiGraphF(
				419,statey+15,	419+224*hpsub,	statey+15,
							419+224*hpsub,	statey+25,	
				419, statey+25,
				img_etc[7],FALSE);
		}
	}
	if(ch_savedata.gamemode_mp_bomb==1){
		char gbomb[64];//{\
		sprintf_s(gbomb, "BOMB %d / %d", ch.bomb, ch.bomb_max);
		DrawString(419, statey+30, gbomb, color[0]);
		for(i=0;i<ch.bomb;i++)
			DrawGraph(419+12*i,statey+45,img_etc[9],TRUE);
	}
	else if(ch_savedata.gamemode_mp_bomb==0){
		double mpsub = 0.9*ch.mp/ch.mp_max;
		char gmp[64];
		sprintf_s(gmp, "MP %d / %d", ch.mp, ch.mp_max);
		DrawString(419, statey+30, gmp, color[0]);
		if(ch.mp>0){
				DrawModiGraphF(
				419,statey+45,	419+224*mpsub,	statey+45,
							419+224*mpsub,	statey+55,	
				419,statey+55,
				img_etc[8],FALSE);
		}
	}

	int sx =550,sy[15];
	for(i=0;i<15;i++)
		sy[i]=175+i*20;

	//p[\
	DrawStringToHandle(433, sy[0]-FY/2,	"POWER",	color[5], font[5]);
	for(i=0;i<3;i++){
		DrawRotaGraph(sx-14*i,sy[0],1.0f,0.0f,img_num[0][power%10],TRUE);
		power/=10;
	}
	//|Cg\
	//OCY\
	//HIT\
	DrawStringToHandle(433, sy[1]-FY/2,	"POINT", color[3], font[5]);
	DrawStringToHandle(433, sy[2]-FY/2,	"GRAZE", color[8], font[5]);
	DrawStringToHandle(433, sy[3]-FY/2,	"HIT",	color[8], font[5]);
	for(i=0;i<4;i++){
		DrawRotaGraph(sx-14*i,sy[1],1.0f,0.0f,img_num[0][point%10],TRUE);
		point/=10;
		DrawRotaGraph(sx-14*i,sy[2],1.0f,0.0f,img_num[0][graze%10],TRUE);
		graze/=10;
		DrawRotaGraph(sx-14*i,sy[3],1.0f,0.0f,img_num[0][hit%10],TRUE);
		hit/=10;
	}

	int ssx =sx-14;
	//skillA\
	DrawStringToHandle(433, sy[5]-FY/2,	"SKILLA",	color[0], font[5]);
	for(i=0;i<skillA;i++){
		DrawRotaGraph(ssx-14*2+14*i,sy[5],1.0f,0.0f,img_num[3][0],TRUE);
	}
	//skillB\
	DrawStringToHandle(433, sy[6]-FY/2,	"SKILLB",	color[0], font[5]);
	for(i=0;i<skillB;i++){
		DrawRotaGraph(ssx-14*2+14*i,sy[6],1.0f,0.0f,img_num[3][0],TRUE);
	}
	//atk\
	DrawStringToHandle(433, sy[7]-FY/2,	"ATK",	color[0], font[5]);
	for(i=0;i<3;i++){
		if(atk>=0)
			DrawRotaGraph(ssx-14*i,sy[7],1.0f,0.0f,img_num[0][atk%10],TRUE);
		else
			DrawRotaGraph(ssx-14*i,sy[7],1.0f,0.0f,img_num[1][(-1*atk)%10],TRUE);
		atk/=10;
	}
	//atksub\
	DrawStringToHandle(433, sy[8]-FY/2,	"ATK_s",	color[0], font[5]);
	for(i=0;i<3;i++){
		if(atksub>=0)
			DrawRotaGraph(ssx-14*i,sy[8],1.0f,0.0f,img_num[0][atksub%10],TRUE);
		else
			DrawRotaGraph(ssx-14*i,sy[8],1.0f,0.0f,img_num[1][(-1*atksub)%10],TRUE);
		atksub/=10;
	}
	//def\
	DrawStringToHandle(433, sy[9]-FY/2,	"DEF",	color[0], font[5]);
	for(i=0;i<3;i++){
		if(def>=0)
			DrawRotaGraph(ssx-14*i,sy[9],1.0f,0.0f,img_num[0][def%10],TRUE);
		else
			DrawRotaGraph(ssx-14*i,sy[9],1.0f,0.0f,img_num[1][(-1*def)%10],TRUE);
		def/=10;
	}
	//dex\
	DrawStringToHandle(433,		sy[10]-FY/2,	"DEX",	color[0], font[5]);
	for(i=0;i<3;i++){
		if(dex>=0)
			DrawRotaGraph(ssx-14*i,sy[10],1.0f,0.0f,img_num[0][dex%10],TRUE);
		else
			DrawRotaGraph(ssx-14*i,sy[10],1.0f,0.0f,img_num[1][(-1*dex)%10],TRUE);
		dex/=10;
	}
	//dexsub\
	DrawStringToHandle(433,		sy[11]-FY/2,	"DEX_s",	color[0], font[5]);
	for(i=0;i<3;i++){
		if(dexsub>=0)
			DrawRotaGraph(ssx-14*i,sy[11],1.0f,0.0f,img_num[0][dexsub%10],TRUE);
		else
			DrawRotaGraph(ssx-14*i,sy[11],1.0f,0.0f,img_num[1][(-1*dexsub)%10],TRUE);
		dexsub/=10;
	}
	//spd\
	DrawStringToHandle(433,		sy[12]-FY/2,	"spd",	color[0], font[5]);
	for(i=0;i<3;i++){
		if(spd>=0)
			DrawRotaGraph(ssx-14*i,sy[12],1.0f,0.0f,img_num[0][spd%10],TRUE);
		else
			DrawRotaGraph(ssx-14*i,sy[12],1.0f,0.0f,img_num[1][(-1*spd)%10],TRUE);
		spd/=10;
	}
	//eva\
	DrawStringToHandle(433,		sy[13]-FY/2,	"eva",	color[0], font[5]);
	for(i=0;i<3;i++){
		if(eva>=0)
			DrawRotaGraph(ssx-14*i,sy[13],1.0f,0.0f,img_num[0][eva%10],TRUE);
		else
			DrawRotaGraph(ssx-14*i,sy[13],1.0f,0.0f,img_num[1][(-1*eva)%10],TRUE);
		eva/=10;
	}
	//luc\
	DrawStringToHandle(433,		sy[14]-FY/2,	"luc",	color[0], font[5]);
	for(i=0;i<3;i++){
		if(luc>=0)
			DrawRotaGraph(ssx-14*i,sy[14],1.0f,0.0f,img_num[0][luc%10],TRUE);
		else
			DrawRotaGraph(ssx-14*i,sy[14],1.0f,0.0f,img_num[1][(-1*luc)%10],TRUE);
		luc/=10;
	}
}

//{[h`
void graph_board(){
	DrawGraph( 0, 0,img_board[charamode], TRUE);

	graph_board_bgm();
	graph_board_states();//(41)
}

//tbV`(42)
void graph_flash(){
	if(flash.flag>0){
		SetDrawBlendMode( DX_BLENDMODE_ALPHA, (int)(flash.brt) );
		DrawBox(FX,FY,FX+FMX,FY+FMY,flash.col,TRUE);
		SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0 );
	}
}

void graph_main(){
	if(stage_num==5 && result.flag>=2 && etc_count>60)
		return;

	if(talk.state<=4 && talk.cnt[0]<150){
		if(bright_set.brt!=255)SetDrawBright(bright_set.brt,bright_set.brt,bright_set.brt);
		SetDrawArea( 32 , 16 , 416 , 464 ) ;//`\GAݒ
	
		graph_back_main();//wi`惁C

		graph_effect(0);//GʃGtFNg
		graph_effect(4);//炢{̃GtFNg

		if(bright_set.brt!=255)SetDrawBright(bright_set.brt,bright_set.brt,bright_set.brt);
		if(special_mode_stop==1)SetDrawBright(255,255,255);

		graph_boss();//{X`

		if(bright_set.brt!=255)SetDrawBright(bright_set.brt,bright_set.brt,bright_set.brt);
	
		graph_cshot();//@Vbg̕`
		graph_ch();//@̕`
		graph_enemy();//G̕`
		graph_effect(7);//OCY

		graph_back_sub();

		if(stage_num==2){
			graph_cshot();//@Vbg̕`
			graph_ch();//@̕`
		}

		graph_item();//ACe`

		if(bright_set.brt!=255)SetDrawBright(bright_set.brt,bright_set.brt,bright_set.brt);
		if(special_mode_stop==1)SetDrawBright(255,255,255);

		graph_bullet();//e̕`
		graph_lazer();//[U[̕`

		if(bright_set.brt!=255)SetDrawBright(255,255,255);
	
		graph_back_sub1();

		graph_hp();
		if(ch.state[8]>0){
			SetDrawBlendMode( DX_BLENDMODE_ALPHA, ch.state[8]*25);
			DrawBox(32,16,416,464,color[1],TRUE);
			SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0) ;
		}
		graph_effect(6);
		graph_effect(5);
		graph_effect(1);//{̃GtFNgAlpAr[
		graph_effect(3);//{̃GtFNg
		graph_effect(2);//{̃L
		graph_effect(10);//{XL̃XLJn
		if((charamode==0 && ch.subA_flag>0) || (charamode==1 && ch.subA_flag==2))
			graph_ch();//@̕`
		graph_stage_title();//^Cg̕\

		SetDrawArea( 0, 0, 640, 480);//GA߂

		graph_board();//{[h̕`
		graph_flash();//tbV`
		if((stage_num==0 || stage_num==6) && stage_count<=60 && menu[eScene_Practice].flag ==0)
			SceneMgr_Draw();

		boss_skill__boss_pos();
	}
	graph_back06proend();

	if(menu[eScene_Practice].flag >0){
		int bx =boss.x, by =boss.y;
		int cx =ch.x, cy =ch.y;
		DrawFormatStringToHandle(250, 80, color[0], font[5],		"{XW[%3d,%3d]", bx, by);
		DrawFormatStringToHandle(250, 100, color[0], font[5],		"@W[%3d,%3d]", cx, cy);
		if(boss.state==2)
			DrawFormatStringToHandle(250, 120, color[0], font[5],	"퓬ԁ@ [%4d]",boss_shot.cnt);
		DrawFormatStringToHandle(250, 140, color[0], font[5],	"ԁ@ [%4d]",stage_count);
		DrawFormatStringToHandle(250, 160, color[0], font[5],		"{Xgo[%5d]", boss.hp);
	}
//	draw_fps(0,465);//fps`
//	draw_func_tm(450,250);//ԕ`
}